/* vsccompletionshell.c generated by valac, the Vala compiler
 * generated from vsccompletionshell.vala, do not modify */

/*
 *  vtgsymbolcompletionshell.vala - Vala developer toys for GEdit
 *  
 *  Copyright (C) 2008 - Andrea Del Signore <sejerpz@tin.it>
 *  
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *   
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *   
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330,
 *  Boston, MA 02111-1307, USA.
 */

#include <glib.h>
#include <glib-object.h>
#include <vsc.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <readline/readline.h>
#include <glib/gstdio.h>
#include <valagee.h>
#include <vala.h>


#define VSC_TYPE_COMPLETION_SHELL (vsc_completion_shell_get_type ())
#define VSC_COMPLETION_SHELL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VSC_TYPE_COMPLETION_SHELL, VscCompletionShell))
#define VSC_COMPLETION_SHELL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VSC_TYPE_COMPLETION_SHELL, VscCompletionShellClass))
#define VSC_IS_COMPLETION_SHELL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VSC_TYPE_COMPLETION_SHELL))
#define VSC_IS_COMPLETION_SHELL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VSC_TYPE_COMPLETION_SHELL))
#define VSC_COMPLETION_SHELL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VSC_TYPE_COMPLETION_SHELL, VscCompletionShellClass))

typedef struct _VscCompletionShell VscCompletionShell;
typedef struct _VscCompletionShellClass VscCompletionShellClass;
typedef struct _VscCompletionShellPrivate VscCompletionShellPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _vsc_symbol_completion_filter_options_unref0(var) ((var == NULL) ? NULL : (var = (vsc_symbol_completion_filter_options_unref (var), NULL)))
#define _vala_collection_object_unref0(var) ((var == NULL) ? NULL : (var = (vala_collection_object_unref (var), NULL)))
#define _vala_code_node_unref0(var) ((var == NULL) ? NULL : (var = (vala_code_node_unref (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _fclose0(var) ((var == NULL) ? NULL : (var = (fclose (var), NULL)))
#define _g_option_context_free0(var) ((var == NULL) ? NULL : (var = (g_option_context_free (var), NULL)))

struct _VscCompletionShell {
	GObject parent_instance;
	VscCompletionShellPrivate * priv;
};

struct _VscCompletionShellClass {
	GObjectClass parent_class;
};

struct _VscCompletionShellPrivate {
	VscSymbolCompletion* _completion;
	char* redirect_filename;
};


static char* vsc_completion_shell_option_execute_script;
static char* vsc_completion_shell_option_execute_script = NULL;
static gpointer vsc_completion_shell_parent_class = NULL;

GType vsc_completion_shell_get_type (void);
#define VSC_COMPLETION_SHELL_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VSC_TYPE_COMPLETION_SHELL, VscCompletionShellPrivate))
enum  {
	VSC_COMPLETION_SHELL_DUMMY_PROPERTY
};
static gboolean vsc_completion_shell_execute_command (VscCompletionShell* self, const char* command);
void vsc_completion_shell_run (VscCompletionShell* self, const char* script);
void vsc_completion_shell_print_message (VscCompletionShell* self, const char* message);
static void vsc_completion_shell_add_package (VscCompletionShell* self, const char* packagename);
static void vsc_completion_shell_type_name (VscCompletionShell* self, const char* word, const char* source, gint line, gint col);
void vsc_completion_shell_print_error (VscCompletionShell* self, const char* message);
static void vsc_completion_shell_complete (VscCompletionShell* self, const char* typename, const char* source, gint line, gint col);
static void vsc_completion_shell_add_source (VscCompletionShell* self, const char* filename, gboolean secondary);
static void vsc_completion_shell_remove_source (VscCompletionShell* self, const char* filename, gboolean secondary);
static void vsc_completion_shell_update_source (VscCompletionShell* self, const char* filename, gboolean secondary);
static void vsc_completion_shell_add_package_from_namespace (VscCompletionShell* self, const char* namespace);
static void vsc_completion_shell_execute (VscCompletionShell* self, const char* filename);
static void vsc_completion_shell_reparse (VscCompletionShell* self, gboolean both_context);
static void vsc_completion_shell_set_redirect_file (VscCompletionShell* self, const char* filename);
static void vsc_completion_shell_get_namespaces (VscCompletionShell* self);
static void vsc_completion_shell_get_classes (VscCompletionShell* self, const char* filename);
static void vsc_completion_shell_visible_types (VscCompletionShell* self, const char* filename, gint line, gint column);
static void vsc_completion_shell_visible_symbols (VscCompletionShell* self, const char* filename, gint line, gint column);
static void vsc_completion_shell_display_result (VscCompletionShell* self, VscSymbolCompletionResult* completions);
static char* vsc_completion_shell_get_access (VscSymbolCompletionItem* symbol);
static void vsc_completion_shell_append_symbols (VscCompletionShell* self, const char* type, GString* sb, ValaList* symbols);
static void vsc_completion_shell_append_methods (GString* sb, ValaList* methods);
VscCompletionShell* vsc_completion_shell_new (void);
VscCompletionShell* vsc_completion_shell_construct (GType object_type);
gint vsc_completion_shell_main (char** args, int args_length1);
static void vsc_completion_shell_finalize (GObject* obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);
static int _vala_strcmp0 (const char * str1, const char * str2);

static const GOptionEntry VSC_COMPLETION_SHELL_options[] = {{"exec", 'e', 0, G_OPTION_ARG_STRING, &vsc_completion_shell_option_execute_script, "Execute script", "FILE"}, {NULL}};


static char* string_strip (const char* self) {
	char* result;
	char* _result_;
	g_return_val_if_fail (self != NULL, NULL);
	_result_ = g_strdup (self);
	g_strstrip (_result_);
	result = _result_;
	return result;
}


void vsc_completion_shell_run (VscCompletionShell* self, const char* script) {
	gboolean exit;
	g_return_if_fail (self != NULL);
	exit = FALSE;
	vsc_parser_manager_resume_parsing (vsc_symbol_completion_get_parser (self->priv->_completion));
	if (script != NULL) {
		char* _tmp0_;
		exit = !vsc_completion_shell_execute_command (self, _tmp0_ = g_strdup_printf ("execute %s", script));
		_g_free0 (_tmp0_);
	}
	while (TRUE) {
		char* line;
		gboolean _tmp1_ = FALSE;
		if (!(!exit)) {
			break;
		}
		line = readline ("> ");
		if (line != NULL) {
			_tmp1_ = _vala_strcmp0 (line, "") != 0;
		} else {
			_tmp1_ = FALSE;
		}
		if (_tmp1_) {
			char* _tmp2_;
			add_history (line);
			exit = !vsc_completion_shell_execute_command (self, _tmp2_ = string_strip (line));
			_g_free0 (_tmp2_);
		}
		_g_free0 (line);
	}
}


static glong string_get_length (const char* self) {
	glong result;
	g_return_val_if_fail (self != NULL, 0L);
	result = g_utf8_strlen (self, -1);
	return result;
}


static gboolean vsc_completion_shell_execute_command (VscCompletionShell* self, const char* command) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (command != NULL, FALSE);
	if (command != NULL) {
		_tmp0_ = string_get_length (command) > 0;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		char** _tmp2_;
		gint toks_size;
		gint toks_length1;
		char** _tmp1_;
		char** toks;
		gint count;
		GQuark _tmp5_;
		const char* _tmp4_;
		static GQuark _tmp5__label0 = 0;
		static GQuark _tmp5__label1 = 0;
		static GQuark _tmp5__label2 = 0;
		static GQuark _tmp5__label3 = 0;
		static GQuark _tmp5__label4 = 0;
		static GQuark _tmp5__label5 = 0;
		static GQuark _tmp5__label6 = 0;
		static GQuark _tmp5__label7 = 0;
		static GQuark _tmp5__label8 = 0;
		static GQuark _tmp5__label9 = 0;
		static GQuark _tmp5__label10 = 0;
		static GQuark _tmp5__label11 = 0;
		static GQuark _tmp5__label12 = 0;
		static GQuark _tmp5__label13 = 0;
		static GQuark _tmp5__label14 = 0;
		static GQuark _tmp5__label15 = 0;
		static GQuark _tmp5__label16 = 0;
		static GQuark _tmp5__label17 = 0;
		toks = (_tmp2_ = _tmp1_ = g_strsplit (command, " ", 0), toks_length1 = _vala_array_length (_tmp1_), toks_size = toks_length1, _tmp2_);
		count = 0;
		while (TRUE) {
			if (!(toks[count] != NULL)) {
				break;
			}
			count++;
		}
		_tmp4_ = toks[0];
		_tmp5_ = (NULL == _tmp4_) ? 0 : g_quark_from_string (_tmp4_);
		if (_tmp5_ == ((0 != _tmp5__label0) ? _tmp5__label0 : (_tmp5__label0 = g_quark_from_static_string ("quit"))))
		do {
			vsc_completion_shell_print_message (self, "Stopping the parser engine");
			vsc_symbol_completion_cleanup (self->priv->_completion);
			vsc_completion_shell_print_message (self, "Bye bye!");
			result = FALSE;
			toks = (_vala_array_free (toks, toks_length1, (GDestroyNotify) g_free), NULL);
			return result;
		} while (0); else if (_tmp5_ == ((0 != _tmp5__label1) ? _tmp5__label1 : (_tmp5__label1 = g_quark_from_static_string ("add-package"))))
		do {
			vsc_completion_shell_add_package (self, toks[1]);
			break;
		} while (0); else if (_tmp5_ == ((0 != _tmp5__label2) ? _tmp5__label2 : (_tmp5__label2 = g_quark_from_static_string ("type-name"))))
		do {
			if (count == 5) {
				gint line;
				gint col;
				line = atoi (toks[3]);
				col = atoi (toks[4]);
				vsc_completion_shell_type_name (self, toks[1], toks[2], line, col);
			} else {
				vsc_completion_shell_print_error (self, "invalid command arguments");
			}
			break;
		} while (0); else if (_tmp5_ == ((0 != _tmp5__label3) ? _tmp5__label3 : (_tmp5__label3 = g_quark_from_static_string ("complete"))))
		do {
			switch (count) {
				case 5:
				{
					vsc_completion_shell_complete (self, toks[1], toks[2], atoi (toks[3]), atoi (toks[4]));
					break;
				}
				case 3:
				{
					vsc_completion_shell_complete (self, toks[1], toks[2], 0, 0);
					break;
				}
				case 2:
				{
					vsc_completion_shell_complete (self, toks[1], NULL, 0, 0);
					break;
				}
				default:
				{
					vsc_completion_shell_print_error (self, "invalid command arguments");
					break;
				}
			}
			break;
		} while (0); else if (_tmp5_ == ((0 != _tmp5__label4) ? _tmp5__label4 : (_tmp5__label4 = g_quark_from_static_string ("add-source"))))
		do {
			if (count == 2) {
				vsc_completion_shell_add_source (self, toks[1], FALSE);
			} else {
				if (count == 3) {
					gboolean sec;
					sec = atoi (toks[2]) != 0;
					vsc_completion_shell_add_source (self, toks[1], sec);
				}
			}
			break;
		} while (0); else if (_tmp5_ == ((0 != _tmp5__label5) ? _tmp5__label5 : (_tmp5__label5 = g_quark_from_static_string ("remove-source"))))
		do {
			if (count == 2) {
				vsc_completion_shell_remove_source (self, toks[1], FALSE);
			} else {
				if (count == 3) {
					gboolean sec;
					sec = atoi (toks[2]) != 0;
					vsc_completion_shell_remove_source (self, toks[1], sec);
				}
			}
			break;
		} while (0); else if (_tmp5_ == ((0 != _tmp5__label6) ? _tmp5__label6 : (_tmp5__label6 = g_quark_from_static_string ("update-source"))))
		do {
			if (count == 2) {
				vsc_completion_shell_update_source (self, toks[1], FALSE);
			} else {
				if (count == 3) {
					gboolean sec;
					sec = atoi (toks[2]) != 0;
					vsc_completion_shell_update_source (self, toks[1], sec);
				}
			}
			break;
		} while (0); else if (_tmp5_ == ((0 != _tmp5__label7) ? _tmp5__label7 : (_tmp5__label7 = g_quark_from_static_string ("add-namespace"))))
		do {
			vsc_completion_shell_add_package_from_namespace (self, toks[1]);
			break;
		} while (0); else if (_tmp5_ == ((0 != _tmp5__label8) ? _tmp5__label8 : (_tmp5__label8 = g_quark_from_static_string ("execute"))))
		do {
			vsc_completion_shell_execute (self, toks[1]);
			break;
		} while (0); else if (_tmp5_ == ((0 != _tmp5__label9) ? _tmp5__label9 : (_tmp5__label9 = g_quark_from_static_string ("reparse"))))
		do {
			vsc_completion_shell_reparse (self, _vala_strcmp0 (toks[1], "both") == 0);
			break;
		} while (0); else if (_tmp5_ == ((0 != _tmp5__label10) ? _tmp5__label10 : (_tmp5__label10 = g_quark_from_static_string ("redirect-output"))))
		do {
			vsc_completion_shell_set_redirect_file (self, toks[1]);
			break;
		} while (0); else if (_tmp5_ == ((0 != _tmp5__label11) ? _tmp5__label11 : (_tmp5__label11 = g_quark_from_static_string ("suspend-parsing"))))
		do {
			vsc_parser_manager_suspend_parsing (vsc_symbol_completion_get_parser (self->priv->_completion));
			break;
		} while (0); else if (_tmp5_ == ((0 != _tmp5__label12) ? _tmp5__label12 : (_tmp5__label12 = g_quark_from_static_string ("resume-parsing"))))
		do {
			vsc_parser_manager_resume_parsing (vsc_symbol_completion_get_parser (self->priv->_completion));
			break;
		} while (0); else if (_tmp5_ == ((0 != _tmp5__label13) ? _tmp5__label13 : (_tmp5__label13 = g_quark_from_static_string ("wait-parser-engine"))))
		do {
			vsc_completion_shell_print_message (self, "waiting parser engine...");
			while (TRUE) {
				if (!vsc_parser_manager_is_cache_building (vsc_symbol_completion_get_parser (self->priv->_completion))) {
					break;
				}
				g_usleep ((gulong) 10000);
			}
			break;
		} while (0); else if (_tmp5_ == ((0 != _tmp5__label14) ? _tmp5__label14 : (_tmp5__label14 = g_quark_from_static_string ("get-namespaces"))))
		do {
			vsc_completion_shell_get_namespaces (self);
			break;
		} while (0); else if (_tmp5_ == ((0 != _tmp5__label15) ? _tmp5__label15 : (_tmp5__label15 = g_quark_from_static_string ("get-classes"))))
		do {
			if (count == 2) {
				vsc_completion_shell_get_classes (self, toks[1]);
			}
			break;
		} while (0); else if (_tmp5_ == ((0 != _tmp5__label16) ? _tmp5__label16 : (_tmp5__label16 = g_quark_from_static_string ("visible-types"))))
		do {
			if (4 == count) {
				vsc_completion_shell_visible_types (self, toks[1], atoi (toks[2]), atoi (toks[3]));
			} else {
				vsc_completion_shell_print_error (self, "invalid command arguments");
			}
			break;
		} while (0); else if (_tmp5_ == ((0 != _tmp5__label17) ? _tmp5__label17 : (_tmp5__label17 = g_quark_from_static_string ("visible-symbols"))))
		do {
			if (4 == count) {
				vsc_completion_shell_visible_symbols (self, toks[1], atoi (toks[2]), atoi (toks[3]));
			} else {
				vsc_completion_shell_print_error (self, "invalid command arguments");
			}
			break;
		} while (0); else
		do {
			char* _tmp3_;
			vsc_completion_shell_print_error (self, _tmp3_ = g_strdup_printf ("unknown command '%s'", command));
			_g_free0 (_tmp3_);
			break;
		} while (0);
		toks = (_vala_array_free (toks, toks_length1, (GDestroyNotify) g_free), NULL);
	}
	result = TRUE;
	return result;
}


static void vsc_completion_shell_set_redirect_file (VscCompletionShell* self, const char* filename) {
	g_return_if_fail (self != NULL);
	if (_vala_strcmp0 (filename, "") == 0) {
		char* _tmp0_;
		self->priv->redirect_filename = (_tmp0_ = NULL, _g_free0 (self->priv->redirect_filename), _tmp0_);
	} else {
		char* _tmp1_;
		self->priv->redirect_filename = (_tmp1_ = g_strdup (filename), _g_free0 (self->priv->redirect_filename), _tmp1_);
	}
}


static void vsc_completion_shell_reparse (VscCompletionShell* self, gboolean both_context) {
	g_return_if_fail (self != NULL);
	vsc_parser_manager_reparse (vsc_symbol_completion_get_parser (self->priv->_completion), both_context);
}


static void vsc_completion_shell_execute (VscCompletionShell* self, const char* filename) {
	GError * _inner_error_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (filename != NULL);
	_inner_error_ = NULL;
	{
		if (g_file_test (filename, G_FILE_TEST_EXISTS)) {
			gsize len = 0UL;
			char* buffer;
			char* _tmp2_;
			gboolean _tmp1_;
			char* _tmp0_ = NULL;
			char* _tmp3_;
			buffer = NULL;
			_tmp1_ = g_file_get_contents (filename, &_tmp0_, &len, &_inner_error_);
			buffer = (_tmp2_ = _tmp0_, _g_free0 (buffer), _tmp2_);
			_tmp1_;
			if (_inner_error_ != NULL) {
				_g_free0 (buffer);
				goto __catch0_g_error;
				goto __finally0;
			}
			vsc_completion_shell_print_message (self, _tmp3_ = g_strdup_printf ("running script '%s'...", filename));
			_g_free0 (_tmp3_);
			{
				char** _tmp4_;
				char** line_collection;
				int line_collection_length1;
				int line_it;
				line_collection = _tmp4_ = g_strsplit (buffer, "\n", 0);
				line_collection_length1 = _vala_array_length (_tmp4_);
				for (line_it = 0; line_it < _vala_array_length (_tmp4_); line_it = line_it + 1) {
					char* line;
					line = g_strdup (line_collection[line_it]);
					{
						char* command;
						gboolean _tmp5_ = FALSE;
						command = string_strip (line);
						if (command != NULL) {
							_tmp5_ = _vala_strcmp0 (command, "") != 0;
						} else {
							_tmp5_ = FALSE;
						}
						if (_tmp5_) {
							char* _tmp6_;
							vsc_completion_shell_print_message (self, _tmp6_ = g_strdup_printf ("   %s", command));
							_g_free0 (_tmp6_);
							vsc_completion_shell_execute_command (self, command);
						}
						_g_free0 (line);
						_g_free0 (command);
					}
				}
				line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
			}
			_g_free0 (buffer);
		} else {
			char* _tmp7_;
			vsc_completion_shell_print_error (self, _tmp7_ = g_strdup_printf ("script file not found: %s", filename));
			_g_free0 (_tmp7_);
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
			vsc_completion_shell_print_error (self, err->message);
			_g_error_free0 (err);
		}
	}
	__finally0:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
		g_clear_error (&_inner_error_);
		return;
	}
}


static void vsc_completion_shell_add_package (VscCompletionShell* self, const char* packagename) {
	GError * _inner_error_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (packagename != NULL);
	_inner_error_ = NULL;
	{
		char* _tmp0_;
		vsc_parser_manager_add_package (vsc_symbol_completion_get_parser (self->priv->_completion), packagename, TRUE, &_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch1_g_error;
			goto __finally1;
		}
		vsc_completion_shell_print_message (self, _tmp0_ = g_strdup_printf ("package '%s' added", packagename));
		_g_free0 (_tmp0_);
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
			vsc_completion_shell_print_error (self, err->message);
			_g_error_free0 (err);
		}
	}
	__finally1:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
		g_clear_error (&_inner_error_);
		return;
	}
}


static void vsc_completion_shell_update_source (VscCompletionShell* self, const char* filename, gboolean secondary) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (filename != NULL);
	vsc_parser_manager_suspend_parsing (vsc_symbol_completion_get_parser (self->priv->_completion));
	vsc_completion_shell_remove_source (self, filename, FALSE);
	vsc_completion_shell_add_source (self, filename, secondary);
	vsc_parser_manager_resume_parsing (vsc_symbol_completion_get_parser (self->priv->_completion));
}


static void vsc_completion_shell_add_source (VscCompletionShell* self, const char* filename, gboolean secondary) {
	GError * _inner_error_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (filename != NULL);
	_inner_error_ = NULL;
	{
		const char* _tmp4_;
		char* _tmp5_;
		if (secondary) {
			char* source;
			gulong len;
			char* _tmp2_;
			gboolean _tmp1_;
			char* _tmp0_ = NULL;
			VscSourceBuffer* _tmp3_;
			source = NULL;
			len = (gulong) 0;
			_tmp1_ = g_file_get_contents (filename, &_tmp0_, &len, &_inner_error_);
			source = (_tmp2_ = _tmp0_, _g_free0 (source), _tmp2_);
			_tmp1_;
			if (_inner_error_ != NULL) {
				_g_free0 (source);
				goto __catch2_g_error;
				goto __finally2;
			}
			vsc_parser_manager_add_source_buffer (vsc_symbol_completion_get_parser (self->priv->_completion), _tmp3_ = vsc_source_buffer_new (filename, source), &_inner_error_);
			if (_inner_error_ != NULL) {
				_g_free0 (source);
				goto __catch2_g_error;
				goto __finally2;
			}
			_g_object_unref0 (_tmp3_);
			_g_free0 (source);
		} else {
			vsc_parser_manager_add_source (vsc_symbol_completion_get_parser (self->priv->_completion), filename, &_inner_error_);
			if (_inner_error_ != NULL) {
				goto __catch2_g_error;
				goto __finally2;
			}
		}
		_tmp4_ = NULL;
		if (secondary) {
			_tmp4_ = "secondary";
		} else {
			_tmp4_ = "primary";
		}
		vsc_completion_shell_print_message (self, _tmp5_ = g_strdup_printf ("source '%s' added to context %s", filename, _tmp4_));
		_g_free0 (_tmp5_);
	}
	goto __finally2;
	__catch2_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
			vsc_completion_shell_print_error (self, err->message);
			_g_error_free0 (err);
		}
	}
	__finally2:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
		g_clear_error (&_inner_error_);
		return;
	}
}


static void vsc_completion_shell_remove_source (VscCompletionShell* self, const char* filename, gboolean secondary) {
	GError * _inner_error_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (filename != NULL);
	_inner_error_ = NULL;
	{
		char* _tmp0_;
		if (secondary) {
			vsc_parser_manager_remove_source_buffer_by_name (vsc_symbol_completion_get_parser (self->priv->_completion), filename, &_inner_error_);
			if (_inner_error_ != NULL) {
				goto __catch3_g_error;
				goto __finally3;
			}
		} else {
			vsc_parser_manager_remove_source (vsc_symbol_completion_get_parser (self->priv->_completion), filename, &_inner_error_);
			if (_inner_error_ != NULL) {
				goto __catch3_g_error;
				goto __finally3;
			}
		}
		vsc_completion_shell_print_message (self, _tmp0_ = g_strdup_printf ("source file '%s' removed", filename));
		_g_free0 (_tmp0_);
	}
	goto __finally3;
	__catch3_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
			vsc_completion_shell_print_error (self, err->message);
			_g_error_free0 (err);
		}
	}
	__finally3:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
		g_clear_error (&_inner_error_);
		return;
	}
}


static void vsc_completion_shell_add_package_from_namespace (VscCompletionShell* self, const char* namespace) {
	GError * _inner_error_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (namespace != NULL);
	_inner_error_ = NULL;
	{
		char* _tmp0_;
		vsc_parser_manager_add_package_from_namespace (vsc_symbol_completion_get_parser (self->priv->_completion), namespace, TRUE, &_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch4_g_error;
			goto __finally4;
		}
		vsc_completion_shell_print_message (self, _tmp0_ = g_strdup_printf ("package '%s' added", namespace));
		_g_free0 (_tmp0_);
	}
	goto __finally4;
	__catch4_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
			vsc_completion_shell_print_error (self, err->message);
			_g_error_free0 (err);
		}
	}
	__finally4:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
		g_clear_error (&_inner_error_);
		return;
	}
}


static void vsc_completion_shell_type_name (VscCompletionShell* self, const char* word, const char* source, gint line, gint col) {
	GError * _inner_error_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (word != NULL);
	g_return_if_fail (source != NULL);
	_inner_error_ = NULL;
	{
		char* typename;
		typename = vsc_symbol_completion_get_datatype_name_for_name (self->priv->_completion, word, source, line, col, &_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch5_g_error;
			goto __finally5;
		}
		if (typename != NULL) {
			char* _tmp0_;
			vsc_completion_shell_print_message (self, _tmp0_ = g_strdup_printf ("typename for %s: %s", word, typename));
			_g_free0 (_tmp0_);
		} else {
			char* _tmp1_;
			vsc_completion_shell_print_message (self, _tmp1_ = g_strdup_printf ("type name not found for %s", word));
			_g_free0 (_tmp1_);
		}
		_g_free0 (typename);
	}
	goto __finally5;
	__catch5_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
			vsc_completion_shell_print_error (self, err->message);
			_g_error_free0 (err);
		}
	}
	__finally5:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
		g_clear_error (&_inner_error_);
		return;
	}
}


static void vsc_completion_shell_complete (VscCompletionShell* self, const char* typename, const char* source, gint line, gint col) {
	GError * _inner_error_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (typename != NULL);
	_inner_error_ = NULL;
	{
		VscSymbolCompletionFilterOptions* options;
		VscSymbolCompletionResult* completion_result;
		options = vsc_symbol_completion_filter_options_new ();
		completion_result = vsc_symbol_completion_get_completions_for_name (self->priv->_completion, options, typename, source, line, col, &_inner_error_);
		if (_inner_error_ != NULL) {
			_vsc_symbol_completion_filter_options_unref0 (options);
			goto __catch6_g_error;
			goto __finally6;
		}
		vsc_completion_shell_display_result (self, completion_result);
		_vsc_symbol_completion_filter_options_unref0 (options);
		_g_object_unref0 (completion_result);
	}
	goto __finally6;
	__catch6_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
			vsc_completion_shell_print_error (self, err->message);
			_g_error_free0 (err);
		}
	}
	__finally6:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
		g_clear_error (&_inner_error_);
		return;
	}
}


static void vsc_completion_shell_get_namespaces (VscCompletionShell* self) {
	VscSymbolCompletionResult* _tmp0_;
	g_return_if_fail (self != NULL);
	vsc_completion_shell_display_result (self, _tmp0_ = vsc_symbol_completion_get_namespaces (self->priv->_completion));
	_g_object_unref0 (_tmp0_);
}


static void vsc_completion_shell_get_classes (VscCompletionShell* self, const char* filename) {
	VscSymbolCompletionResult* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (filename != NULL);
	vsc_completion_shell_display_result (self, _tmp0_ = vsc_symbol_completion_get_classes_for_source (self->priv->_completion, filename));
	_g_object_unref0 (_tmp0_);
}


static void vsc_completion_shell_visible_types (VscCompletionShell* self, const char* filename, gint line, gint column) {
	VscSymbolCompletionResult* _tmp1_;
	VscSymbolCompletionFilterOptions* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (filename != NULL);
	vsc_completion_shell_display_result (self, _tmp1_ = vsc_symbol_completion_get_visible_symbols (self->priv->_completion, _tmp0_ = vsc_symbol_completion_filter_options_new (), filename, line, column, TRUE));
	_g_object_unref0 (_tmp1_);
	_vsc_symbol_completion_filter_options_unref0 (_tmp0_);
}


static void vsc_completion_shell_visible_symbols (VscCompletionShell* self, const char* filename, gint line, gint column) {
	VscSymbolCompletionResult* _tmp1_;
	VscSymbolCompletionFilterOptions* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (filename != NULL);
	vsc_completion_shell_display_result (self, _tmp1_ = vsc_symbol_completion_get_visible_symbols (self->priv->_completion, _tmp0_ = vsc_symbol_completion_filter_options_new (), filename, line, column, FALSE));
	_g_object_unref0 (_tmp1_);
	_vsc_symbol_completion_filter_options_unref0 (_tmp0_);
}


static void vsc_completion_shell_append_symbols (VscCompletionShell* self, const char* type, GString* sb, ValaList* symbols) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (type != NULL);
	g_return_if_fail (sb != NULL);
	g_return_if_fail (symbols != NULL);
	{
		ValaIterator* _symbol_it;
		_symbol_it = vala_iterable_iterator ((ValaIterable*) symbols);
		while (TRUE) {
			VscSymbolCompletionItem* symbol;
			char* _tmp1_;
			char* _tmp0_;
			if (!vala_iterator_next (_symbol_it)) {
				break;
			}
			symbol = (VscSymbolCompletionItem*) vala_iterator_get (_symbol_it);
			g_string_append (sb, _tmp1_ = g_strdup_printf ("%s:%s:%s;:;:;%s:%d;%d;\n", type, symbol->name, _tmp0_ = vsc_completion_shell_get_access (symbol), symbol->file, symbol->first_line, symbol->last_line));
			_g_free0 (_tmp1_);
			_g_free0 (_tmp0_);
			_g_object_unref0 (symbol);
		}
		_vala_collection_object_unref0 (_symbol_it);
	}
}


static gpointer _vala_code_node_ref0 (gpointer self) {
	return self ? vala_code_node_ref (self) : NULL;
}


static void vsc_completion_shell_append_methods (GString* sb, ValaList* methods) {
	ValaMethod* method;
	ValaDataType* sometype;
	char* is_owned;
	char* typename;
	char* paramname;
	g_return_if_fail (sb != NULL);
	g_return_if_fail (methods != NULL);
	method = NULL;
	sometype = NULL;
	is_owned = NULL;
	typename = NULL;
	paramname = NULL;
	{
		ValaIterator* _item_it;
		_item_it = vala_iterable_iterator ((ValaIterable*) methods);
		while (TRUE) {
			VscSymbolCompletionItem* item;
			ValaMethod* _tmp0_;
			if (!vala_iterator_next (_item_it)) {
				break;
			}
			item = (VscSymbolCompletionItem*) vala_iterator_get (_item_it);
			method = (_tmp0_ = _vala_code_node_ref0 (VALA_METHOD (item->symbol)), _vala_code_node_unref0 (method), _tmp0_);
			if (NULL != method) {
				ValaDataType* _tmp1_;
				char* _tmp8_;
				char* _tmp7_;
				char* _tmp22_;
				sometype = (_tmp1_ = _vala_code_node_ref0 (vala_method_get_return_type (method)), _vala_code_node_unref0 (sometype), _tmp1_);
				if (NULL != sometype) {
					char* _tmp2_;
					const char* _tmp3_;
					char* _tmp4_;
					typename = (_tmp2_ = vala_code_node_to_string ((ValaCodeNode*) sometype), _g_free0 (typename), _tmp2_);
					_tmp3_ = NULL;
					if (vala_data_type_get_value_owned (sometype)) {
						_tmp3_ = "";
					} else {
						_tmp3_ = "unowned";
					}
					is_owned = (_tmp4_ = g_strdup (_tmp3_), _g_free0 (is_owned), _tmp4_);
				} else {
					char* _tmp5_;
					char* _tmp6_;
					is_owned = (_tmp5_ = g_strdup (""), _g_free0 (is_owned), _tmp5_);
					typename = (_tmp6_ = g_strdup (""), _g_free0 (typename), _tmp6_);
				}
				g_string_append (sb, _tmp8_ = g_strdup_printf ("method:%s:%s;%s:%s;%s:", item->name, _tmp7_ = vsc_completion_shell_get_access (item), "", typename, is_owned));
				_g_free0 (_tmp8_);
				_g_free0 (_tmp7_);
				{
					ValaList* _tmp9_;
					ValaIterator* _tmp10_;
					ValaIterator* _param_it;
					_param_it = (_tmp10_ = vala_iterable_iterator ((ValaIterable*) (_tmp9_ = vala_method_get_parameters (method))), _vala_collection_object_unref0 (_tmp9_), _tmp10_);
					while (TRUE) {
						ValaFormalParameter* param;
						ValaDataType* _tmp11_;
						const char* _tmp17_;
						char* _tmp18_;
						gboolean _tmp19_;
						char* _tmp20_;
						char* _tmp21_;
						if (!vala_iterator_next (_param_it)) {
							break;
						}
						param = (ValaFormalParameter*) vala_iterator_get (_param_it);
						sometype = (_tmp11_ = _vala_code_node_ref0 (vala_formal_parameter_get_parameter_type (param)), _vala_code_node_unref0 (sometype), _tmp11_);
						if (NULL != sometype) {
							char* _tmp12_;
							const char* _tmp13_;
							char* _tmp14_;
							typename = (_tmp12_ = vala_code_node_to_string ((ValaCodeNode*) sometype), _g_free0 (typename), _tmp12_);
							_tmp13_ = NULL;
							if (vala_data_type_get_value_owned (sometype)) {
								_tmp13_ = "";
							} else {
								_tmp13_ = "unowned";
							}
							is_owned = (_tmp14_ = g_strdup (_tmp13_), _g_free0 (is_owned), _tmp14_);
						} else {
							char* _tmp15_;
							char* _tmp16_;
							is_owned = (_tmp15_ = g_strdup (""), _g_free0 (is_owned), _tmp15_);
							typename = (_tmp16_ = g_strdup (""), _g_free0 (typename), _tmp16_);
						}
						_tmp17_ = NULL;
						if ((_tmp19_ = _vala_strcmp0 ("(null)", _tmp18_ = string_strip (vala_symbol_get_name ((ValaSymbol*) param))) == 0, _g_free0 (_tmp18_), _tmp19_)) {
							_tmp17_ = "...";
						} else {
							_tmp17_ = vala_symbol_get_name ((ValaSymbol*) param);
						}
						paramname = (_tmp20_ = g_strdup (_tmp17_), _g_free0 (paramname), _tmp20_);
						g_string_append (sb, _tmp21_ = g_strdup_printf ("%s,%s,%s;", paramname, typename, is_owned));
						_g_free0 (_tmp21_);
						_vala_code_node_unref0 (param);
					}
					_vala_collection_object_unref0 (_param_it);
				}
				g_string_append (sb, _tmp22_ = g_strdup_printf ("%s:%d;%d;\n", item->file, item->first_line, item->last_line));
				_g_free0 (_tmp22_);
			} else {
				char* _tmp23_;
				g_string_append (sb, _tmp23_ = g_strdup_printf ("method:%s:;:;:;%s:%d;%d;\n", item->name, item->file, item->first_line, item->last_line));
				_g_free0 (_tmp23_);
			}
			_g_object_unref0 (item);
		}
		_vala_collection_object_unref0 (_item_it);
	}
	_vala_code_node_unref0 (method);
	_vala_code_node_unref0 (sometype);
	_g_free0 (is_owned);
	_g_free0 (typename);
	_g_free0 (paramname);
}


static char* vsc_completion_shell_get_access (VscSymbolCompletionItem* symbol) {
	char* result;
	ValaSymbol* sym_real;
	char* access;
	g_return_val_if_fail (symbol != NULL, NULL);
	sym_real = _vala_code_node_ref0 (symbol->symbol);
	access = g_strdup ("");
	if (NULL != sym_real) {
		switch (vala_symbol_get_access (sym_real)) {
			case VALA_SYMBOL_ACCESSIBILITY_PUBLIC:
			{
				char* _tmp0_;
				access = (_tmp0_ = g_strdup ("public"), _g_free0 (access), _tmp0_);
				break;
			}
			case VALA_SYMBOL_ACCESSIBILITY_PRIVATE:
			{
				char* _tmp1_;
				access = (_tmp1_ = g_strdup ("private"), _g_free0 (access), _tmp1_);
				break;
			}
			case VALA_SYMBOL_ACCESSIBILITY_PROTECTED:
			{
				char* _tmp2_;
				access = (_tmp2_ = g_strdup ("protected"), _g_free0 (access), _tmp2_);
				break;
			}
			case VALA_SYMBOL_ACCESSIBILITY_INTERNAL:
			{
				char* _tmp3_;
				access = (_tmp3_ = g_strdup ("internal"), _g_free0 (access), _tmp3_);
				break;
			}
			default:
			{
				break;
			}
		}
	}
	result = access;
	_vala_code_node_unref0 (sym_real);
	return result;
}


static void vsc_completion_shell_display_result (VscCompletionShell* self, VscSymbolCompletionResult* completions) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (completions != NULL);
	if (!vsc_symbol_completion_result_get_is_empty (completions)) {
		GString* sb;
		sb = g_string_new ("");
		vsc_completion_shell_print_message (self, "symbols found");
		if (vala_collection_get_size ((ValaCollection*) completions->enums) > 0) {
			vsc_completion_shell_append_symbols (self, "enums", sb, completions->enums);
		}
		if (vala_collection_get_size ((ValaCollection*) completions->constants) > 0) {
			vsc_completion_shell_append_symbols (self, "constants", sb, completions->constants);
		}
		if (vala_collection_get_size ((ValaCollection*) completions->namespaces) > 0) {
			vsc_completion_shell_append_symbols (self, "namespaces", sb, completions->namespaces);
		}
		if (vala_collection_get_size ((ValaCollection*) completions->fields) > 0) {
			vsc_completion_shell_append_symbols (self, "field", sb, completions->fields);
		}
		if (vala_collection_get_size ((ValaCollection*) completions->properties) > 0) {
			vsc_completion_shell_append_symbols (self, "property", sb, completions->properties);
		}
		if (vala_collection_get_size ((ValaCollection*) completions->methods) > 0) {
			vsc_completion_shell_append_methods (sb, completions->methods);
		}
		if (vala_collection_get_size ((ValaCollection*) completions->signals) > 0) {
			vsc_completion_shell_append_symbols (self, "signal", sb, completions->signals);
		}
		if (vala_collection_get_size ((ValaCollection*) completions->classes) > 0) {
			vsc_completion_shell_append_symbols (self, "class", sb, completions->classes);
		}
		if (vala_collection_get_size ((ValaCollection*) completions->interfaces) > 0) {
			vsc_completion_shell_append_symbols (self, "interface", sb, completions->interfaces);
		}
		if (vala_collection_get_size ((ValaCollection*) completions->structs) > 0) {
			vsc_completion_shell_append_symbols (self, "struct", sb, completions->structs);
		}
		if (vala_collection_get_size ((ValaCollection*) completions->others) > 0) {
			vsc_completion_shell_append_symbols (self, "other", sb, completions->others);
		}
		vsc_completion_shell_print_message (self, sb->str);
		_g_string_free0 (sb);
	} else {
		vsc_completion_shell_print_message (self, "no symbol found");
	}
}


void vsc_completion_shell_print_error (VscCompletionShell* self, const char* message) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (message != NULL);
	fprintf (stdout, "vsc-shell *** ERROR *** - %s\n", message);
	fflush (stdout);
}


void vsc_completion_shell_print_message (VscCompletionShell* self, const char* message) {
	char* data;
	char* _tmp0_;
	char** _tmp2_;
	gint lines_size;
	gint lines_length1;
	char** _tmp1_;
	char** lines;
	FILE* file;
	g_return_if_fail (self != NULL);
	g_return_if_fail (message != NULL);
	data = NULL;
	data = (_tmp0_ = g_strdup_printf ("%s", message), _g_free0 (data), _tmp0_);
	lines = (_tmp2_ = _tmp1_ = g_strsplit (data, "\n", 0), lines_length1 = _vala_array_length (_tmp1_), lines_size = lines_length1, _tmp2_);
	file = NULL;
	if (self->priv->redirect_filename != NULL) {
		FILE* _tmp3_;
		file = (_tmp3_ = fopen (self->priv->redirect_filename, "w+"), _fclose0 (file), _tmp3_);
	}
	{
		char** line_collection;
		int line_collection_length1;
		int line_it;
		line_collection = lines;
		line_collection_length1 = lines_length1;
		for (line_it = 0; line_it < lines_length1; line_it = line_it + 1) {
			char* line;
			line = g_strdup (line_collection[line_it]);
			{
				char* buffer;
				buffer = g_strdup_printf ("vsc-shell - %s\n", line);
				fprintf (stdout, "%s", buffer);
				if (file != NULL) {
					fputs (buffer, file);
				}
				fflush (stdout);
				_g_free0 (line);
				_g_free0 (buffer);
			}
		}
	}
	if (file != NULL) {
		FILE* _tmp4_;
		fflush (file);
		file = (_tmp4_ = NULL, _fclose0 (file), _tmp4_);
	}
	_g_free0 (data);
	lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
	_fclose0 (file);
}


gint vsc_completion_shell_main (char** args, int args_length1) {
	gint result;
	GError * _inner_error_;
	VscCompletionShell* cs;
	_inner_error_ = NULL;
	{
		GOptionContext* opt_context;
		opt_context = g_option_context_new ("- Vsc Completion Shell");
		g_option_context_add_main_entries (opt_context, VSC_COMPLETION_SHELL_options, NULL);
		g_option_context_parse (opt_context, &args_length1, &args, &_inner_error_);
		if (_inner_error_ != NULL) {
			_g_option_context_free0 (opt_context);
			if (_inner_error_->domain == G_OPTION_ERROR) {
				goto __catch7_g_option_error;
			}
			goto __finally7;
		}
		_g_option_context_free0 (opt_context);
	}
	goto __finally7;
	__catch7_g_option_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
			fprintf (stdout, "%s\n", e->message);
			fprintf (stdout, "Run '%s --help' to see a full list of available command line options.\n", args[0]);
			result = 1;
			_g_error_free0 (e);
			return result;
		}
	}
	__finally7:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
		g_clear_error (&_inner_error_);
		return 0;
	}
	cs = vsc_completion_shell_new ();
	vsc_completion_shell_run (cs, vsc_completion_shell_option_execute_script);
	result = 0;
	_g_object_unref0 (cs);
	return result;
}


int main (int argc, char ** argv) {
	g_thread_init (NULL);
	g_type_init ();
	return vsc_completion_shell_main (argv, argc);
}


VscCompletionShell* vsc_completion_shell_construct (GType object_type) {
	VscCompletionShell * self;
	self = (VscCompletionShell*) g_object_new (object_type, NULL);
	return self;
}


VscCompletionShell* vsc_completion_shell_new (void) {
	return vsc_completion_shell_construct (VSC_TYPE_COMPLETION_SHELL);
}


static void vsc_completion_shell_class_init (VscCompletionShellClass * klass) {
	vsc_completion_shell_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (VscCompletionShellPrivate));
	G_OBJECT_CLASS (klass)->finalize = vsc_completion_shell_finalize;
}


static void vsc_completion_shell_instance_init (VscCompletionShell * self) {
	self->priv = VSC_COMPLETION_SHELL_GET_PRIVATE (self);
	self->priv->_completion = vsc_symbol_completion_new ();
	self->priv->redirect_filename = g_strdup ("");
}


static void vsc_completion_shell_finalize (GObject* obj) {
	VscCompletionShell * self;
	self = VSC_COMPLETION_SHELL (obj);
	_g_object_unref0 (self->priv->_completion);
	_g_free0 (self->priv->redirect_filename);
	G_OBJECT_CLASS (vsc_completion_shell_parent_class)->finalize (obj);
}


GType vsc_completion_shell_get_type (void) {
	static GType vsc_completion_shell_type_id = 0;
	if (vsc_completion_shell_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (VscCompletionShellClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vsc_completion_shell_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VscCompletionShell), 0, (GInstanceInitFunc) vsc_completion_shell_instance_init, NULL };
		vsc_completion_shell_type_id = g_type_register_static (G_TYPE_OBJECT, "VscCompletionShell", &g_define_type_info, 0);
	}
	return vsc_completion_shell_type_id;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}




