/* vscparsermanager.c generated by valac, the Vala compiler
 * generated from vscparsermanager.vala, do not modify */

/*
 *  vscparsermanager.vala - Vala symbol completion library
 *  
 *  Copyright (C) 2008 - Andrea Del Signore <sejerpz@tin.it>
 *  
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <valagee.h>
#include <vala.h>
#include <glib/gstdio.h>
#include <config.h>


#define VSC_TYPE_PARSER_MANAGER (vsc_parser_manager_get_type ())
#define VSC_PARSER_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VSC_TYPE_PARSER_MANAGER, VscParserManager))
#define VSC_PARSER_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VSC_TYPE_PARSER_MANAGER, VscParserManagerClass))
#define VSC_IS_PARSER_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VSC_TYPE_PARSER_MANAGER))
#define VSC_IS_PARSER_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VSC_TYPE_PARSER_MANAGER))
#define VSC_PARSER_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VSC_TYPE_PARSER_MANAGER, VscParserManagerClass))

typedef struct _VscParserManager VscParserManager;
typedef struct _VscParserManagerClass VscParserManagerClass;
typedef struct _VscParserManagerPrivate VscParserManagerPrivate;

#define VSC_TYPE_SOURCE_BUFFER (vsc_source_buffer_get_type ())
#define VSC_SOURCE_BUFFER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VSC_TYPE_SOURCE_BUFFER, VscSourceBuffer))
#define VSC_SOURCE_BUFFER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VSC_TYPE_SOURCE_BUFFER, VscSourceBufferClass))
#define VSC_IS_SOURCE_BUFFER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VSC_TYPE_SOURCE_BUFFER))
#define VSC_IS_SOURCE_BUFFER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VSC_TYPE_SOURCE_BUFFER))
#define VSC_SOURCE_BUFFER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VSC_TYPE_SOURCE_BUFFER, VscSourceBufferClass))

typedef struct _VscSourceBuffer VscSourceBuffer;
typedef struct _VscSourceBufferClass VscSourceBufferClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define __g_list_free_g_free0(var) ((var == NULL) ? NULL : (var = (_g_list_free_g_free (var), NULL)))
#define _vala_collection_object_unref0(var) ((var == NULL) ? NULL : (var = (vala_collection_object_unref (var), NULL)))
#define _vala_code_context_unref0(var) ((var == NULL) ? NULL : (var = (vala_code_context_unref (var), NULL)))
#define _g_mutex_free0(var) ((var == NULL) ? NULL : (var = (g_mutex_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _vala_source_file_unref0(var) ((var == NULL) ? NULL : (var = (vala_source_file_unref (var), NULL)))
#define _vala_code_node_unref0(var) ((var == NULL) ? NULL : (var = (vala_code_node_unref (var), NULL)))
#define _vala_code_visitor_unref0(var) ((var == NULL) ? NULL : (var = (vala_code_visitor_unref (var), NULL)))
#define _g_dir_close0(var) ((var == NULL) ? NULL : (var = (g_dir_close (var), NULL)))

struct _VscParserManager {
	GObject parent_instance;
	VscParserManagerPrivate * priv;
};

struct _VscParserManagerClass {
	GObjectClass parent_class;
};

struct _VscParserManagerPrivate {
	char* glib_file;
	char* gobject_file;
	GList* _vapidirs;
	ValaList* _packages;
	ValaList* _built_packages;
	ValaList* _sources;
	ValaList* _source_buffers;
	ValaCodeContext* _pri_context;
	ValaCodeContext* _sec_context;
	gint need_parse_sec_context;
	gint need_parse_pri_context;
	GThread* parser_pri_thread;
	GThread* parser_sec_thread;
	GMutex* mutex_pri_context;
	GMutex* mutex_sec_context;
	gboolean parsing_suspended;
};

typedef enum  {
	VSC_SYMBOL_COMPLETION_ERROR_PACKAGE_FILE_NOT_FOUND,
	VSC_SYMBOL_COMPLETION_ERROR_PACKAGE_ALREADY_ADDED,
	VSC_SYMBOL_COMPLETION_ERROR_UNSUPPORTED_SYMBOL_TYPE,
	VSC_SYMBOL_COMPLETION_ERROR_UNSUPPORTED_TYPE,
	VSC_SYMBOL_COMPLETION_ERROR_SOURCE_BUFFER
} VscSymbolCompletionError;
#define VSC_SYMBOL_COMPLETION_ERROR vsc_symbol_completion_error_quark ()

static gpointer vsc_parser_manager_parent_class = NULL;

GType vsc_parser_manager_get_type (void);
GType vsc_source_buffer_get_type (void);
#define VSC_PARSER_MANAGER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VSC_TYPE_PARSER_MANAGER, VscParserManagerPrivate))
enum  {
	VSC_PARSER_MANAGER_DUMMY_PROPERTY,
	VSC_PARSER_MANAGER_PRI_CONTEXT,
	VSC_PARSER_MANAGER_SEC_CONTEXT
};
static void _g_list_free_g_free (GList* self);
static void vsc_parser_manager_lock_all_contexts (VscParserManager* self);
static void vsc_parser_manager_unlock_all_contexts (VscParserManager* self);
static void vsc_parser_manager_lock_pri_context (VscParserManager* self);
static void vsc_parser_manager_unlock_pri_context (VscParserManager* self);
static void vsc_parser_manager_lock_sec_context (VscParserManager* self);
static void vsc_parser_manager_unlock_sec_context (VscParserManager* self);
static void* vsc_parser_manager_parse_pri_contexts (VscParserManager* self);
static void* _vsc_parser_manager_parse_pri_contexts_gthread_func (gpointer self);
static void vsc_parser_manager_create_pri_thread (VscParserManager* self);
static void* vsc_parser_manager_parse_sec_contexts (VscParserManager* self);
static void* _vsc_parser_manager_parse_sec_contexts_gthread_func (gpointer self);
static void vsc_parser_manager_create_sec_thread (VscParserManager* self);
void vsc_parser_manager_suspend_parsing (VscParserManager* self);
static void vsc_parser_manager_schedule_parse (VscParserManager* self);
void vsc_parser_manager_resume_parsing (VscParserManager* self);
gboolean vsc_parser_manager_add_path_to_vapi_search_dir (VscParserManager* self, const char* path);
static gboolean vsc_parser_manager_list_contains_string (VscParserManager* self, ValaList* list, const char* value);
gboolean vsc_parser_manager_add_built_package (VscParserManager* self, const char* vapi_file);
gboolean vsc_parser_manager_remove_build_package (VscParserManager* self, const char* vapi_file);
static char* vsc_parser_manager_find_vala_package_name (VscParserManager* self, const char* namespace, GError** error);
gboolean vsc_parser_manager_add_package (VscParserManager* self, const char* package_name, gboolean auto_schedule_parse, GError** error);
gboolean vsc_parser_manager_add_package_from_namespace (VscParserManager* self, const char* namespace, gboolean auto_schedule_parse, GError** error);
void vsc_parser_manager_remove_package (VscParserManager* self, const char* package_name, GError** error);
void vsc_parser_manager_remove_package_from_namespace (VscParserManager* self, const char* namespace, GError** error);
static ValaList* vsc_parser_manager_find_vala_package_filenames (VscParserManager* self, const char* package_name, GError** error);
gboolean vsc_parser_manager_try_add_package (VscParserManager* self, const char* package_name, gboolean auto_schedule_parse);
GQuark vsc_symbol_completion_error_quark (void);
void vsc_parser_manager_add_source (VscParserManager* self, const char* filename, GError** error);
void vsc_parser_manager_remove_source (VscParserManager* self, const char* filename, GError** error);
gboolean vsc_parser_manager_contains_source (VscParserManager* self, const char* filename);
gboolean vsc_parser_manager_contains_source_buffer (VscParserManager* self, VscSourceBuffer* source);
static void vsc_parser_manager_schedule_parse_source_buffers (VscParserManager* self);
void vsc_parser_manager_add_source_buffer (VscParserManager* self, VscSourceBuffer* source, GError** error);
const char* vsc_source_buffer_get_name (VscSourceBuffer* self);
void vsc_parser_manager_remove_source_buffer (VscParserManager* self, VscSourceBuffer* source);
void vsc_parser_manager_remove_source_buffer_by_name (VscParserManager* self, const char* name, GError** error);
gboolean vsc_parser_manager_contains_source_buffer_by_name (VscParserManager* self, const char* name);
void vsc_parser_manager_reparse_source_buffers (VscParserManager* self);
gboolean vsc_parser_manager_is_cache_building (VscParserManager* self);
void vsc_parser_manager_reparse (VscParserManager* self, gboolean all_context);
static void vsc_parser_manager_parse (VscParserManager* self);
static void vsc_parser_manager_parse_source_buffers (VscParserManager* self);
const char* vsc_source_buffer_get_source (VscSourceBuffer* self);
void vsc_parser_manager_parse_context (VscParserManager* self, ValaCodeContext* context);
static void vsc_parser_manager_analyze_context (VscParserManager* self, ValaCodeContext* context);
VscParserManager* vsc_parser_manager_new (void);
VscParserManager* vsc_parser_manager_construct (GType object_type);
ValaCodeContext* vsc_parser_manager_get_pri_context (VscParserManager* self);
ValaCodeContext* vsc_parser_manager_get_sec_context (VscParserManager* self);
static GObject * vsc_parser_manager_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void vsc_parser_manager_finalize (GObject* obj);
static void vsc_parser_manager_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);
static int _vala_strcmp0 (const char * str1, const char * str2);



static void _g_list_free_g_free (GList* self) {
	g_list_foreach (self, (GFunc) g_free, NULL);
	g_list_free (self);
}


static void vsc_parser_manager_lock_all_contexts (VscParserManager* self) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (self->priv->mutex_pri_context != NULL);
	g_mutex_lock (self->priv->mutex_pri_context);
	g_return_if_fail (self->priv->mutex_sec_context != NULL);
	g_mutex_lock (self->priv->mutex_sec_context);
}


static void vsc_parser_manager_unlock_all_contexts (VscParserManager* self) {
	g_return_if_fail (self != NULL);
	if (self->priv->mutex_sec_context != NULL) {
		g_mutex_unlock (self->priv->mutex_sec_context);
	}
	if (self->priv->mutex_pri_context != NULL) {
		g_mutex_unlock (self->priv->mutex_pri_context);
	}
}


static void vsc_parser_manager_lock_pri_context (VscParserManager* self) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (self->priv->mutex_pri_context != NULL);
	g_mutex_lock (self->priv->mutex_pri_context);
}


static void vsc_parser_manager_unlock_pri_context (VscParserManager* self) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (self->priv->mutex_pri_context != NULL);
	g_mutex_unlock (self->priv->mutex_pri_context);
}


static void vsc_parser_manager_lock_sec_context (VscParserManager* self) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (self->priv->mutex_sec_context != NULL);
	g_mutex_lock (self->priv->mutex_sec_context);
}


static void vsc_parser_manager_unlock_sec_context (VscParserManager* self) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (self->priv->mutex_sec_context != NULL);
	g_mutex_unlock (self->priv->mutex_sec_context);
}


static void* _vsc_parser_manager_parse_pri_contexts_gthread_func (gpointer self) {
	return vsc_parser_manager_parse_pri_contexts (self);
}


static void vsc_parser_manager_create_pri_thread (VscParserManager* self) {
	GError * _inner_error_;
	g_return_if_fail (self != NULL);
	_inner_error_ = NULL;
	{
		GThread* _tmp0_;
		if (self->priv->parser_pri_thread != NULL) {
			g_thread_join (self->priv->parser_pri_thread);
		}
		_tmp0_ = g_thread_create (_vsc_parser_manager_parse_pri_contexts_gthread_func, self, TRUE, &_inner_error_);
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_THREAD_ERROR) {
				goto __catch6_g_thread_error;
			}
			goto __finally6;
		}
		self->priv->parser_pri_thread = _tmp0_;
	}
	goto __finally6;
	__catch6_g_thread_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
			g_error ("vscparsermanager.vala:178: Can't create parser thread: %s", err->message);
			_g_error_free0 (err);
		}
	}
	__finally6:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
		g_clear_error (&_inner_error_);
		return;
	}
}


static void* _vsc_parser_manager_parse_sec_contexts_gthread_func (gpointer self) {
	return vsc_parser_manager_parse_sec_contexts (self);
}


static void vsc_parser_manager_create_sec_thread (VscParserManager* self) {
	GError * _inner_error_;
	g_return_if_fail (self != NULL);
	_inner_error_ = NULL;
	if (self->priv->parsing_suspended) {
		return;
	}
	{
		GThread* _tmp0_;
		if (self->priv->parser_sec_thread != NULL) {
			g_thread_join (self->priv->parser_sec_thread);
		}
		_tmp0_ = g_thread_create (_vsc_parser_manager_parse_sec_contexts_gthread_func, self, TRUE, &_inner_error_);
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_THREAD_ERROR) {
				goto __catch7_g_thread_error;
			}
			goto __finally7;
		}
		self->priv->parser_sec_thread = _tmp0_;
	}
	goto __finally7;
	__catch7_g_thread_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
			g_error ("vscparsermanager.vala:193: Can't create parser thread: %s", err->message);
			_g_error_free0 (err);
		}
	}
	__finally7:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
		g_clear_error (&_inner_error_);
		return;
	}
}


void vsc_parser_manager_suspend_parsing (VscParserManager* self) {
	g_return_if_fail (self != NULL);
	vsc_parser_manager_lock_all_contexts (self);
	self->priv->parsing_suspended = TRUE;
	vsc_parser_manager_unlock_all_contexts (self);
}


void vsc_parser_manager_resume_parsing (VscParserManager* self) {
	g_return_if_fail (self != NULL);
	vsc_parser_manager_lock_all_contexts (self);
	self->priv->parsing_suspended = FALSE;
	vsc_parser_manager_unlock_all_contexts (self);
	vsc_parser_manager_schedule_parse (self);
}


gboolean vsc_parser_manager_add_path_to_vapi_search_dir (VscParserManager* self, const char* path) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (path != NULL, FALSE);
	if (!g_file_test (path, G_FILE_TEST_IS_DIR)) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_list_find_custom (self->priv->_vapidirs, path, strcmp) != NULL;
	}
	if (_tmp0_) {
		result = FALSE;
		return result;
	}
	self->priv->_vapidirs = g_list_append (self->priv->_vapidirs, g_strdup (path));
	vsc_parser_manager_schedule_parse (self);
	result = TRUE;
	return result;
}


gboolean vsc_parser_manager_add_built_package (VscParserManager* self, const char* vapi_file) {
	gboolean result;
	gboolean _result_;
	char* built_vapi_file;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (vapi_file != NULL, FALSE);
	_result_ = FALSE;
	built_vapi_file = NULL;
	if (g_str_has_suffix (vapi_file, ".vapi")) {
		char* _tmp0_;
		built_vapi_file = (_tmp0_ = g_strdup (vapi_file), _g_free0 (built_vapi_file), _tmp0_);
	} else {
		char* _tmp1_;
		built_vapi_file = (_tmp1_ = g_strdup_printf ("%s.vapi", vapi_file), _g_free0 (built_vapi_file), _tmp1_);
	}
	if (!vsc_parser_manager_list_contains_string (self, self->priv->_built_packages, built_vapi_file)) {
		_result_ = TRUE;
		vala_collection_add ((ValaCollection*) self->priv->_built_packages, built_vapi_file);
		vsc_parser_manager_schedule_parse (self);
	}
	result = _result_;
	_g_free0 (built_vapi_file);
	return result;
}


gboolean vsc_parser_manager_remove_build_package (VscParserManager* self, const char* vapi_file) {
	gboolean result;
	gboolean _result_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (vapi_file != NULL, FALSE);
	_result_ = FALSE;
	if (vsc_parser_manager_list_contains_string (self, self->priv->_built_packages, vapi_file)) {
		_result_ = TRUE;
		vala_collection_remove ((ValaCollection*) self->priv->_built_packages, vapi_file);
		vsc_parser_manager_schedule_parse (self);
	}
	result = _result_;
	return result;
}


gboolean vsc_parser_manager_add_package_from_namespace (VscParserManager* self, const char* namespace, gboolean auto_schedule_parse, GError** error) {
	gboolean result;
	GError * _inner_error_;
	char* package_name;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (namespace != NULL, FALSE);
	_inner_error_ = NULL;
	if (namespace == NULL) {
		result = FALSE;
		return result;
	}
	package_name = vsc_parser_manager_find_vala_package_name (self, namespace, &_inner_error_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return FALSE;
	}
	if (package_name != NULL) {
		gboolean _tmp0_;
		_tmp0_ = vsc_parser_manager_add_package (self, package_name, auto_schedule_parse, &_inner_error_);
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			_g_free0 (package_name);
			return FALSE;
		}
		result = _tmp0_;
		_g_free0 (package_name);
		return result;
	} else {
		result = FALSE;
		_g_free0 (package_name);
		return result;
	}
	_g_free0 (package_name);
}


void vsc_parser_manager_remove_package_from_namespace (VscParserManager* self, const char* namespace, GError** error) {
	GError * _inner_error_;
	char* package_name;
	g_return_if_fail (self != NULL);
	g_return_if_fail (namespace != NULL);
	_inner_error_ = NULL;
	package_name = vsc_parser_manager_find_vala_package_name (self, namespace, &_inner_error_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return;
	}
	vsc_parser_manager_remove_package (self, package_name, &_inner_error_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_free0 (package_name);
		return;
	}
	_g_free0 (package_name);
}


void vsc_parser_manager_remove_package (VscParserManager* self, const char* package_name, GError** error) {
	GError * _inner_error_;
	ValaList* files;
	char* _tmp0_;
	gboolean _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (package_name != NULL);
	_inner_error_ = NULL;
	files = vsc_parser_manager_find_vala_package_filenames (self, package_name, &_inner_error_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return;
	}
	if ((_tmp1_ = vsc_parser_manager_list_contains_string (self, self->priv->_packages, _tmp0_ = (char*) vala_list_get (files, 0)), _g_free0 (_tmp0_), _tmp1_)) {
		char* _tmp2_;
		vsc_parser_manager_lock_pri_context (self);
		vala_collection_remove ((ValaCollection*) files, _tmp2_ = (char*) vala_list_get (files, 0));
		_g_free0 (_tmp2_);
		vsc_parser_manager_unlock_pri_context (self);
		vsc_parser_manager_schedule_parse (self);
	}
	_vala_collection_object_unref0 (files);
}


gboolean vsc_parser_manager_try_add_package (VscParserManager* self, const char* package_name, gboolean auto_schedule_parse) {
	gboolean result;
	GError * _inner_error_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (package_name != NULL, FALSE);
	_inner_error_ = NULL;
	{
		vsc_parser_manager_add_package (self, package_name, auto_schedule_parse, &_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch8_g_error;
			goto __finally8;
		}
		result = TRUE;
		return result;
	}
	goto __finally8;
	__catch8_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
			result = FALSE;
			_g_error_free0 (err);
			return result;
		}
	}
	__finally8:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
}


static char* string_replace (const char* self, const char* old, const char* replacement) {
	char* result;
	GError * _inner_error_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	_inner_error_ = NULL;
	{
		char* _tmp0_;
		GRegex* _tmp1_;
		GRegex* regex;
		char* _tmp2_;
		regex = (_tmp1_ = g_regex_new (_tmp0_ = g_regex_escape_string (old, -1), 0, 0, &_inner_error_), _g_free0 (_tmp0_), _tmp1_);
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch9_g_regex_error;
			}
			goto __finally9;
		}
		_tmp2_ = g_regex_replace_literal (regex, self, (glong) (-1), 0, replacement, 0, &_inner_error_);
		if (_inner_error_ != NULL) {
			_g_regex_unref0 (regex);
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch9_g_regex_error;
			}
			goto __finally9;
		}
		result = _tmp2_;
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally9;
	__catch9_g_regex_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
			g_assert_not_reached ();
			_g_error_free0 (e);
		}
	}
	__finally9:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


gboolean vsc_parser_manager_add_package (VscParserManager* self, const char* package_name, gboolean auto_schedule_parse, GError** error) {
	gboolean result;
	GError * _inner_error_;
	char* vapi_file;
	ValaList* files;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (package_name != NULL, FALSE);
	_inner_error_ = NULL;
	vapi_file = NULL;
	if (g_str_has_suffix (package_name, ".vapi")) {
		char* _tmp0_;
		vapi_file = (_tmp0_ = g_strdup (package_name), _g_free0 (vapi_file), _tmp0_);
	} else {
		char* _tmp1_;
		vapi_file = (_tmp1_ = g_strdup_printf ("%s.vapi", package_name), _g_free0 (vapi_file), _tmp1_);
	}
	if (vsc_parser_manager_list_contains_string (self, self->priv->_built_packages, vapi_file)) {
		result = FALSE;
		_g_free0 (vapi_file);
		return result;
	}
	files = vsc_parser_manager_find_vala_package_filenames (self, vapi_file, &_inner_error_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_free0 (vapi_file);
		return FALSE;
	}
	if (vala_collection_get_size ((ValaCollection*) files) > 0) {
		gboolean need_parse;
		gboolean _tmp4_ = FALSE;
		need_parse = FALSE;
		vsc_parser_manager_lock_pri_context (self);
		{
			ValaIterator* _filename_it;
			_filename_it = vala_iterable_iterator ((ValaIterable*) files);
			while (TRUE) {
				char* filename;
				if (!vala_iterator_next (_filename_it)) {
					break;
				}
				filename = (char*) vala_iterator_get (_filename_it);
				if (!vsc_parser_manager_list_contains_string (self, self->priv->_packages, filename)) {
					gboolean _tmp2_ = FALSE;
					if (g_str_has_suffix (filename, "gee-1.0.vapi")) {
						char* _tmp3_;
						_tmp2_ = vsc_parser_manager_list_contains_string (self, self->priv->_packages, _tmp3_ = string_replace (filename, "gee-1.0.vapi", "vala-1.0.vapi"));
						_g_free0 (_tmp3_);
					} else {
						_tmp2_ = FALSE;
					}
					if (_tmp2_) {
						_g_free0 (filename);
						continue;
					}
					vala_collection_add ((ValaCollection*) self->priv->_packages, filename);
					need_parse = TRUE;
				}
				_g_free0 (filename);
			}
			_vala_collection_object_unref0 (_filename_it);
		}
		vsc_parser_manager_unlock_pri_context (self);
		if (need_parse) {
			_tmp4_ = auto_schedule_parse;
		} else {
			_tmp4_ = FALSE;
		}
		if (_tmp4_) {
			vsc_parser_manager_schedule_parse (self);
		}
		result = need_parse;
		_g_free0 (vapi_file);
		_vala_collection_object_unref0 (files);
		return result;
	} else {
		_inner_error_ = g_error_new_literal (VSC_SYMBOL_COMPLETION_ERROR, VSC_SYMBOL_COMPLETION_ERROR_PACKAGE_FILE_NOT_FOUND, "package file not found");
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			_g_free0 (vapi_file);
			_vala_collection_object_unref0 (files);
			return FALSE;
		}
	}
	_g_free0 (vapi_file);
	_vala_collection_object_unref0 (files);
}


void vsc_parser_manager_add_source (VscParserManager* self, const char* filename, GError** error) {
	GError * _inner_error_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (filename != NULL);
	_inner_error_ = NULL;
	if (g_file_test (filename, G_FILE_TEST_EXISTS)) {
		if (!vsc_parser_manager_list_contains_string (self, self->priv->_sources, filename)) {
			vsc_parser_manager_lock_pri_context (self);
			vala_collection_add ((ValaCollection*) self->priv->_sources, filename);
			vsc_parser_manager_unlock_pri_context (self);
			vsc_parser_manager_schedule_parse (self);
		}
	} else {
		_inner_error_ = g_error_new_literal (VSC_SYMBOL_COMPLETION_ERROR, VSC_SYMBOL_COMPLETION_ERROR_PACKAGE_FILE_NOT_FOUND, "source file not found");
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			return;
		}
	}
}


void vsc_parser_manager_remove_source (VscParserManager* self, const char* filename, GError** error) {
	GError * _inner_error_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (filename != NULL);
	_inner_error_ = NULL;
	if (!vsc_parser_manager_list_contains_string (self, self->priv->_sources, filename)) {
		vsc_parser_manager_lock_pri_context (self);
		vala_collection_remove ((ValaCollection*) self->priv->_sources, filename);
		vsc_parser_manager_unlock_pri_context (self);
		vsc_parser_manager_schedule_parse (self);
	} else {
		_inner_error_ = g_error_new_literal (VSC_SYMBOL_COMPLETION_ERROR, VSC_SYMBOL_COMPLETION_ERROR_PACKAGE_FILE_NOT_FOUND, "source file not found");
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			return;
		}
	}
}


gboolean vsc_parser_manager_contains_source (VscParserManager* self, const char* filename) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (filename != NULL, FALSE);
	result = vsc_parser_manager_list_contains_string (self, self->priv->_sources, filename);
	return result;
}


void vsc_parser_manager_add_source_buffer (VscParserManager* self, VscSourceBuffer* source, GError** error) {
	GError * _inner_error_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (source != NULL);
	_inner_error_ = NULL;
	if (vsc_parser_manager_contains_source_buffer (self, source)) {
		_inner_error_ = g_error_new_literal (VSC_SYMBOL_COMPLETION_ERROR, VSC_SYMBOL_COMPLETION_ERROR_SOURCE_BUFFER, "source already added");
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == VSC_SYMBOL_COMPLETION_ERROR) {
				g_propagate_error (error, _inner_error_);
				return;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
				g_clear_error (&_inner_error_);
				return;
			}
		}
	}
	vsc_parser_manager_lock_sec_context (self);
	vala_collection_add ((ValaCollection*) self->priv->_source_buffers, source);
	vsc_parser_manager_unlock_sec_context (self);
	vsc_parser_manager_schedule_parse_source_buffers (self);
}


void vsc_parser_manager_remove_source_buffer_by_name (VscParserManager* self, const char* name, GError** error) {
	GError * _inner_error_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (name != NULL);
	_inner_error_ = NULL;
	{
		ValaIterator* _item_it;
		_item_it = vala_iterable_iterator ((ValaIterable*) self->priv->_source_buffers);
		while (TRUE) {
			VscSourceBuffer* item;
			if (!vala_iterator_next (_item_it)) {
				break;
			}
			item = (VscSourceBuffer*) vala_iterator_get (_item_it);
			if (_vala_strcmp0 (vsc_source_buffer_get_name (item), name) == 0) {
				vsc_parser_manager_remove_source_buffer (self, item);
				_g_object_unref0 (item);
				_vala_collection_object_unref0 (_item_it);
				return;
			}
			_g_object_unref0 (item);
		}
		_vala_collection_object_unref0 (_item_it);
	}
	_inner_error_ = g_error_new_literal (VSC_SYMBOL_COMPLETION_ERROR, VSC_SYMBOL_COMPLETION_ERROR_SOURCE_BUFFER, "source not found");
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == VSC_SYMBOL_COMPLETION_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


gboolean vsc_parser_manager_contains_source_buffer (VscParserManager* self, VscSourceBuffer* source) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (source != NULL, FALSE);
	result = vsc_parser_manager_contains_source_buffer_by_name (self, vsc_source_buffer_get_name (source));
	return result;
}


gboolean vsc_parser_manager_contains_source_buffer_by_name (VscParserManager* self, const char* name) {
	gboolean result;
	gboolean _result_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (name != NULL, FALSE);
	_result_ = FALSE;
	vsc_parser_manager_lock_sec_context (self);
	{
		ValaIterator* _item_it;
		_item_it = vala_iterable_iterator ((ValaIterable*) self->priv->_source_buffers);
		while (TRUE) {
			VscSourceBuffer* item;
			if (!vala_iterator_next (_item_it)) {
				break;
			}
			item = (VscSourceBuffer*) vala_iterator_get (_item_it);
			if (_vala_strcmp0 (vsc_source_buffer_get_name (item), name) == 0) {
				_result_ = TRUE;
				_g_object_unref0 (item);
				break;
			}
			_g_object_unref0 (item);
		}
		_vala_collection_object_unref0 (_item_it);
	}
	vsc_parser_manager_unlock_sec_context (self);
	result = _result_;
	return result;
}


void vsc_parser_manager_remove_source_buffer (VscParserManager* self, VscSourceBuffer* source) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (source != NULL);
	vsc_parser_manager_lock_sec_context (self);
	vala_collection_remove ((ValaCollection*) self->priv->_source_buffers, source);
	vsc_parser_manager_unlock_sec_context (self);
	vsc_parser_manager_schedule_parse_source_buffers (self);
}


void vsc_parser_manager_reparse_source_buffers (VscParserManager* self) {
	g_return_if_fail (self != NULL);
	vsc_parser_manager_schedule_parse_source_buffers (self);
}


gboolean vsc_parser_manager_is_cache_building (VscParserManager* self) {
	gboolean result;
	gboolean _result_;
	gboolean _tmp0_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_result_ = FALSE;
	if (self->priv->need_parse_pri_context > 0) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = self->priv->need_parse_sec_context > 0;
	}
	_result_ = _tmp0_;
	result = _result_;
	return result;
}


void vsc_parser_manager_reparse (VscParserManager* self, gboolean all_context) {
	g_return_if_fail (self != NULL);
	vsc_parser_manager_schedule_parse_source_buffers (self);
	if (all_context) {
		vsc_parser_manager_schedule_parse (self);
	}
}


static void vsc_parser_manager_schedule_parse_source_buffers (VscParserManager* self) {
	g_return_if_fail (self != NULL);
	if (self->priv->parsing_suspended) {
		return;
	}
	if (g_atomic_int_compare_and_exchange (&self->priv->need_parse_sec_context, 0, 1)) {
		vsc_parser_manager_create_sec_thread (self);
	} else {
		g_atomic_int_inc (&self->priv->need_parse_sec_context);
	}
}


static void vsc_parser_manager_schedule_parse (VscParserManager* self) {
	g_return_if_fail (self != NULL);
	if (self->priv->parsing_suspended) {
		return;
	}
	if (g_atomic_int_compare_and_exchange (&self->priv->need_parse_pri_context, 0, 1)) {
		vsc_parser_manager_create_pri_thread (self);
	} else {
		g_atomic_int_inc (&self->priv->need_parse_pri_context);
	}
}


static void* vsc_parser_manager_parse_pri_contexts (VscParserManager* self) {
	void* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_signal_emit_by_name (self, "caches-building");
	while (TRUE) {
		gint stamp;
		stamp = g_atomic_int_get (&self->priv->need_parse_pri_context);
		vsc_parser_manager_parse (self);
		if (g_atomic_int_compare_and_exchange (&self->priv->need_parse_pri_context, stamp, 0)) {
			break;
		}
	}
	g_signal_emit_by_name (self, "caches-builded");
	result = (void*) 0;
	return result;
}


static void* vsc_parser_manager_parse_sec_contexts (VscParserManager* self) {
	void* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_signal_emit_by_name (self, "caches-building");
	while (TRUE) {
		gint stamp;
		stamp = g_atomic_int_get (&self->priv->need_parse_sec_context);
		vsc_parser_manager_parse_source_buffers (self);
		if (g_atomic_int_compare_and_exchange (&self->priv->need_parse_sec_context, stamp, 0)) {
			break;
		}
	}
	g_signal_emit_by_name (self, "sec-cache-builded");
	g_signal_emit_by_name (self, "caches-builded");
	result = (void*) 0;
	return result;
}


static gpointer _vala_code_context_ref0 (gpointer self) {
	return self ? vala_code_context_ref (self) : NULL;
}


static void vsc_parser_manager_parse_source_buffers (VscParserManager* self) {
	GError * _inner_error_;
	ValaCodeContext* current_context;
	g_return_if_fail (self != NULL);
	_inner_error_ = NULL;
	current_context = vala_code_context_new ();
	vala_code_context_push (current_context);
	vsc_parser_manager_lock_sec_context (self);
	if (vala_collection_get_size ((ValaCollection*) self->priv->_source_buffers) != 0) {
		ValaSourceFile* source;
		ValaSourceFile* _tmp0_;
		ValaSourceFile* _tmp1_;
		gboolean need_reparse;
		ValaCodeContext* _tmp11_;
		source = NULL;
		source = (_tmp0_ = vala_source_file_new (current_context, self->priv->glib_file, TRUE, NULL), _vala_source_file_unref0 (source), _tmp0_);
		vala_code_context_add_source_file (current_context, source);
		source = (_tmp1_ = vala_source_file_new (current_context, self->priv->gobject_file, TRUE, NULL), _vala_source_file_unref0 (source), _tmp1_);
		vala_code_context_add_source_file (current_context, source);
		{
			ValaIterator* _src_it;
			_src_it = vala_iterable_iterator ((ValaIterable*) self->priv->_source_buffers);
			while (TRUE) {
				VscSourceBuffer* src;
				gboolean _tmp2_ = FALSE;
				if (!vala_iterator_next (_src_it)) {
					break;
				}
				src = (VscSourceBuffer*) vala_iterator_get (_src_it);
				if (vsc_source_buffer_get_name (src) != NULL) {
					_tmp2_ = vsc_source_buffer_get_source (src) != NULL;
				} else {
					_tmp2_ = FALSE;
				}
				if (_tmp2_) {
					char* name;
					ValaSourceFile* _tmp4_;
					ValaUsingDirective* _tmp6_;
					ValaUnresolvedSymbol* _tmp5_;
					name = g_strdup (vsc_source_buffer_get_name (src));
					if (!g_str_has_suffix (name, ".vala")) {
						char* _tmp3_;
						name = (_tmp3_ = g_strdup_printf ("%s.vala", name), _g_free0 (name), _tmp3_);
					}
					source = (_tmp4_ = vala_source_file_new (current_context, name, FALSE, vsc_source_buffer_get_source (src)), _vala_source_file_unref0 (source), _tmp4_);
					vala_source_file_add_using_directive (source, _tmp6_ = vala_using_directive_new ((ValaSymbol*) (_tmp5_ = vala_unresolved_symbol_new (NULL, "GLib", NULL)), NULL));
					_vala_code_node_unref0 (_tmp6_);
					_vala_code_node_unref0 (_tmp5_);
					vala_code_context_add_source_file (current_context, source);
					_g_free0 (name);
				}
				_g_object_unref0 (src);
			}
			_vala_collection_object_unref0 (_src_it);
		}
		vsc_parser_manager_unlock_sec_context (self);
		vsc_parser_manager_parse_context (self, current_context);
		vsc_parser_manager_lock_sec_context (self);
		need_reparse = FALSE;
		{
			ValaList* _tmp7_;
			ValaIterator* _tmp8_;
			ValaIterator* _src_it;
			_src_it = (_tmp8_ = vala_iterable_iterator ((ValaIterable*) (_tmp7_ = vala_code_context_get_source_files (current_context))), _vala_collection_object_unref0 (_tmp7_), _tmp8_);
			while (TRUE) {
				ValaSourceFile* src;
				if (!vala_iterator_next (_src_it)) {
					break;
				}
				src = (ValaSourceFile*) vala_iterator_get (_src_it);
				{
					ValaIterator* _nr_it;
					_nr_it = vala_iterable_iterator ((ValaIterable*) vala_source_file_get_current_using_directives (src));
					while (TRUE) {
						ValaUsingDirective* nr;
						if (!vala_iterator_next (_nr_it)) {
							break;
						}
						nr = (ValaUsingDirective*) vala_iterator_get (_nr_it);
						{
							gboolean _tmp9_ = FALSE;
							if (vala_symbol_get_name (vala_using_directive_get_namespace_symbol (nr)) != NULL) {
								_tmp9_ = _vala_strcmp0 (vala_symbol_get_name (vala_using_directive_get_namespace_symbol (nr)), "") != 0;
							} else {
								_tmp9_ = FALSE;
							}
							if (_tmp9_) {
								gboolean _tmp10_;
								_tmp10_ = vsc_parser_manager_add_package_from_namespace (self, vala_symbol_get_name (vala_using_directive_get_namespace_symbol (nr)), FALSE, &_inner_error_);
								if (_inner_error_ != NULL) {
									goto __catch10_g_error;
									goto __finally10;
								}
								need_reparse = _tmp10_;
							}
						}
						goto __finally10;
						__catch10_g_error:
						{
							GError * err;
							err = _inner_error_;
							_inner_error_ = NULL;
							{
								g_warning ("vscparsermanager.vala:544: Error adding namespace %s from file %s", vala_symbol_get_name (vala_using_directive_get_namespace_symbol (nr)), vala_source_file_get_filename (src));
								_g_error_free0 (err);
							}
						}
						__finally10:
						if (_inner_error_ != NULL) {
							_vala_code_node_unref0 (nr);
							_vala_collection_object_unref0 (_nr_it);
							_vala_source_file_unref0 (src);
							_vala_collection_object_unref0 (_src_it);
							_vala_source_file_unref0 (source);
							_vala_code_context_unref0 (current_context);
							g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
							g_clear_error (&_inner_error_);
							return;
						}
						_vala_code_node_unref0 (nr);
					}
					_vala_collection_object_unref0 (_nr_it);
				}
				_vala_source_file_unref0 (src);
			}
			_vala_collection_object_unref0 (_src_it);
		}
		self->priv->_sec_context = (_tmp11_ = _vala_code_context_ref0 (current_context), _vala_code_context_unref0 (self->priv->_sec_context), _tmp11_);
		if (need_reparse) {
			vsc_parser_manager_schedule_parse (self);
		}
		_vala_source_file_unref0 (source);
	}
	vsc_parser_manager_unlock_sec_context (self);
	vala_code_context_pop ();
	_vala_code_context_unref0 (current_context);
}


static void vsc_parser_manager_parse (VscParserManager* self) {
	ValaCodeContext* current_context;
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	current_context = vala_code_context_new ();
	vala_code_context_push (current_context);
	vsc_parser_manager_lock_pri_context (self);
	if (vala_collection_get_size ((ValaCollection*) self->priv->_packages) != 0) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = vala_collection_get_size ((ValaCollection*) self->priv->_sources) != 0;
	}
	if (_tmp0_) {
		ValaSourceFile* source;
		ValaSourceFile* _tmp1_;
		ValaSourceFile* _tmp2_;
		ValaCodeContext* _tmp9_;
		source = NULL;
		source = (_tmp1_ = vala_source_file_new (current_context, self->priv->glib_file, TRUE, NULL), _vala_source_file_unref0 (source), _tmp1_);
		vala_code_context_add_source_file (current_context, source);
		source = (_tmp2_ = vala_source_file_new (current_context, self->priv->gobject_file, TRUE, NULL), _vala_source_file_unref0 (source), _tmp2_);
		vala_code_context_add_source_file (current_context, source);
		{
			ValaIterator* _item_it;
			_item_it = vala_iterable_iterator ((ValaIterable*) self->priv->_packages);
			while (TRUE) {
				char* item;
				gboolean _tmp3_ = FALSE;
				gboolean _tmp4_ = FALSE;
				if (!vala_iterator_next (_item_it)) {
					break;
				}
				item = (char*) vala_iterator_get (_item_it);
				if (item != NULL) {
					_tmp4_ = _vala_strcmp0 (item, self->priv->glib_file) != 0;
				} else {
					_tmp4_ = FALSE;
				}
				if (_tmp4_) {
					_tmp3_ = _vala_strcmp0 (item, self->priv->gobject_file) != 0;
				} else {
					_tmp3_ = FALSE;
				}
				if (_tmp3_) {
					ValaSourceFile* _tmp5_;
					source = (_tmp5_ = vala_source_file_new (current_context, item, TRUE, NULL), _vala_source_file_unref0 (source), _tmp5_);
					vala_code_context_add_source_file (current_context, source);
				}
				_g_free0 (item);
			}
			_vala_collection_object_unref0 (_item_it);
		}
		{
			ValaIterator* _item_it;
			_item_it = vala_iterable_iterator ((ValaIterable*) self->priv->_sources);
			while (TRUE) {
				char* item;
				ValaSourceFile* _tmp6_;
				ValaUsingDirective* _tmp8_;
				ValaUnresolvedSymbol* _tmp7_;
				if (!vala_iterator_next (_item_it)) {
					break;
				}
				item = (char*) vala_iterator_get (_item_it);
				source = (_tmp6_ = vala_source_file_new (current_context, item, FALSE, NULL), _vala_source_file_unref0 (source), _tmp6_);
				vala_source_file_add_using_directive (source, _tmp8_ = vala_using_directive_new ((ValaSymbol*) (_tmp7_ = vala_unresolved_symbol_new (NULL, "GLib", NULL)), NULL));
				_vala_code_node_unref0 (_tmp8_);
				_vala_code_node_unref0 (_tmp7_);
				vala_code_context_add_source_file (current_context, source);
				_g_free0 (item);
			}
			_vala_collection_object_unref0 (_item_it);
		}
		vsc_parser_manager_unlock_pri_context (self);
		vsc_parser_manager_parse_context (self, current_context);
		if (vala_report_get_errors (vala_code_context_get_report (current_context)) == 0) {
			vsc_parser_manager_analyze_context (self, current_context);
		}
		vsc_parser_manager_lock_pri_context (self);
		self->priv->_pri_context = (_tmp9_ = _vala_code_context_ref0 (current_context), _vala_code_context_unref0 (self->priv->_pri_context), _tmp9_);
		_vala_source_file_unref0 (source);
	}
	vsc_parser_manager_unlock_pri_context (self);
	vala_code_context_pop ();
	_vala_code_context_unref0 (current_context);
}


void vsc_parser_manager_parse_context (VscParserManager* self, ValaCodeContext* context) {
	gint glib_major;
	gint glib_minor;
	ValaParser* parser;
	g_return_if_fail (self != NULL);
	g_return_if_fail (context != NULL);
	vala_code_context_set_assert (context, FALSE);
	vala_code_context_set_checking (context, FALSE);
	vala_code_context_set_experimental (context, FALSE);
	vala_code_context_set_experimental_non_null (context, FALSE);
	vala_code_context_set_compile_only (context, TRUE);
	vala_code_context_set_profile (context, VALA_PROFILE_GOBJECT);
	vala_code_context_add_define (context, "GOBJECT");
	vala_code_context_add_define (context, "VALA_0_7_6_NEW_METHODS");
	glib_major = 2;
	glib_minor = 12;
	vala_code_context_set_target_glib_major (context, glib_major);
	vala_code_context_set_target_glib_minor (context, glib_minor);
	parser = vala_parser_new ();
	vala_parser_parse (parser, context);
	_vala_code_visitor_unref0 (parser);
}


static void vsc_parser_manager_analyze_context (VscParserManager* self, ValaCodeContext* context) {
	ValaSymbolResolver* symbol_resolver;
	g_return_if_fail (self != NULL);
	g_return_if_fail (context != NULL);
	symbol_resolver = vala_symbol_resolver_new ();
	vala_symbol_resolver_resolve (symbol_resolver, context);
	if (vala_report_get_errors (vala_code_context_get_report (context)) == 0) {
		ValaSemanticAnalyzer* semantic;
		semantic = vala_semantic_analyzer_new ();
		vala_semantic_analyzer_analyze (semantic, context);
		_vala_code_visitor_unref0 (semantic);
	}
	_vala_code_visitor_unref0 (symbol_resolver);
}


static char* vsc_parser_manager_find_vala_package_name (VscParserManager* self, const char* namespace, GError** error) {
	char* result;
	GError * _inner_error_;
	char** _tmp5_;
	gint to_finds_size;
	gint to_finds_length1;
	char** _tmp3_ = NULL;
	char* _tmp2_;
	char* _tmp1_;
	char* _tmp0_;
	char** _tmp4_;
	char** to_finds;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (namespace != NULL, NULL);
	_inner_error_ = NULL;
	to_finds = (_tmp5_ = (_tmp4_ = (_tmp3_ = g_new0 (char*, 3 + 1), _tmp3_[0] = g_strdup_printf ("%s.", _tmp0_ = g_utf8_strdown (namespace, -1)), _tmp3_[1] = g_strdup_printf ("%s-", _tmp1_ = g_utf8_strdown (namespace, -1)), _tmp3_[2] = g_strdup_printf ("%s+", _tmp2_ = g_utf8_strdown (namespace, -1)), _tmp3_), _g_free0 (_tmp2_), _g_free0 (_tmp1_), _g_free0 (_tmp0_), _tmp4_), to_finds_length1 = 3, to_finds_size = to_finds_length1, _tmp5_);
	{
		GList* vapidir_collection;
		GList* vapidir_it;
		vapidir_collection = self->priv->_vapidirs;
		for (vapidir_it = vapidir_collection; vapidir_it != NULL; vapidir_it = vapidir_it->next) {
			char* vapidir;
			vapidir = g_strdup ((const char*) vapidir_it->data);
			{
				GDir* dir;
				char* filename;
				dir = NULL;
				{
					GDir* _tmp6_;
					GDir* _tmp7_;
					_tmp6_ = g_dir_open (vapidir, 0, &_inner_error_);
					if (_inner_error_ != NULL) {
						if (_inner_error_->domain == G_FILE_ERROR) {
							goto __catch11_g_file_error;
						}
						goto __finally11;
					}
					dir = (_tmp7_ = _tmp6_, _g_dir_close0 (dir), _tmp7_);
				}
				goto __finally11;
				__catch11_g_file_error:
				{
					GError * err;
					err = _inner_error_;
					_inner_error_ = NULL;
					{
						_g_error_free0 (err);
						_g_free0 (vapidir);
						_g_dir_close0 (dir);
						continue;
					}
				}
				__finally11:
				if (_inner_error_ != NULL) {
					g_propagate_error (error, _inner_error_);
					_g_free0 (vapidir);
					_g_dir_close0 (dir);
					to_finds = (_vala_array_free (to_finds, to_finds_length1, (GDestroyNotify) g_free), NULL);
					return NULL;
				}
				filename = g_strdup (g_dir_read_name (dir));
				while (TRUE) {
					char* _tmp9_;
					if (!(filename != NULL)) {
						break;
					}
					if (g_str_has_suffix (filename, "vapi")) {
						char* _tmp8_;
						filename = (_tmp8_ = g_utf8_strdown (filename, -1), _g_free0 (filename), _tmp8_);
						{
							char** to_find_collection;
							int to_find_collection_length1;
							int to_find_it;
							to_find_collection = to_finds;
							to_find_collection_length1 = to_finds_length1;
							for (to_find_it = 0; to_find_it < to_finds_length1; to_find_it = to_find_it + 1) {
								char* to_find;
								to_find = g_strdup (to_find_collection[to_find_it]);
								{
									if (g_str_has_prefix (filename, to_find)) {
										result = filename;
										_g_free0 (to_find);
										_g_free0 (vapidir);
										_g_dir_close0 (dir);
										to_finds = (_vala_array_free (to_finds, to_finds_length1, (GDestroyNotify) g_free), NULL);
										return result;
									}
									_g_free0 (to_find);
								}
							}
						}
					}
					filename = (_tmp9_ = g_strdup (g_dir_read_name (dir)), _g_free0 (filename), _tmp9_);
				}
				_g_free0 (vapidir);
				_g_dir_close0 (dir);
				_g_free0 (filename);
			}
		}
	}
	result = NULL;
	to_finds = (_vala_array_free (to_finds, to_finds_length1, (GDestroyNotify) g_free), NULL);
	return result;
}


static char* string_substring (const char* self, glong offset, glong len) {
	char* result;
	glong string_length;
	const char* start;
	g_return_val_if_fail (self != NULL, NULL);
	string_length = g_utf8_strlen (self, -1);
	if (offset < 0) {
		offset = string_length + offset;
		g_return_val_if_fail (offset >= 0, NULL);
	} else {
		g_return_val_if_fail (offset <= string_length, NULL);
	}
	if (len < 0) {
		len = string_length - offset;
	}
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
	start = g_utf8_offset_to_pointer (self, offset);
	result = g_strndup (start, ((gchar*) g_utf8_offset_to_pointer (start, len)) - ((gchar*) start));
	return result;
}


static glong string_get_length (const char* self) {
	glong result;
	g_return_val_if_fail (self != NULL, 0L);
	result = g_utf8_strlen (self, -1);
	return result;
}


static ValaList* vsc_parser_manager_find_vala_package_filenames (VscParserManager* self, const char* package_name, GError** error) {
	ValaList* result;
	GError * _inner_error_;
	ValaList* results;
	char* found_vapidir;
	char* filename;
	char* path;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (package_name != NULL, NULL);
	_inner_error_ = NULL;
	results = (ValaList*) vala_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, g_direct_equal);
	found_vapidir = NULL;
	filename = NULL;
	path = NULL;
	if (!g_str_has_suffix (package_name, ".vapi")) {
		char* _tmp0_;
		filename = (_tmp0_ = g_strdup_printf ("%s.vapi", package_name), _g_free0 (filename), _tmp0_);
	} else {
		char* _tmp1_;
		filename = (_tmp1_ = g_strdup (package_name), _g_free0 (filename), _tmp1_);
	}
	{
		GList* vapidir_collection;
		GList* vapidir_it;
		vapidir_collection = self->priv->_vapidirs;
		for (vapidir_it = vapidir_collection; vapidir_it != NULL; vapidir_it = vapidir_it->next) {
			char* vapidir;
			vapidir = g_strdup ((const char*) vapidir_it->data);
			{
				char* _tmp2_;
				path = (_tmp2_ = g_strdup_printf ("%s/%s", vapidir, filename), _g_free0 (path), _tmp2_);
				if (g_file_test (path, G_FILE_TEST_EXISTS)) {
					char* _tmp3_;
					vala_collection_add ((ValaCollection*) results, path);
					found_vapidir = (_tmp3_ = g_strdup (vapidir), _g_free0 (found_vapidir), _tmp3_);
					_g_free0 (vapidir);
					break;
				}
				_g_free0 (vapidir);
			}
		}
	}
	if (vala_collection_get_size ((ValaCollection*) results) > 0) {
		char* _tmp4_;
		char* _tmp5_;
		char* dep_file;
		dep_file = (_tmp5_ = g_strdup_printf ("%s/%s.deps", found_vapidir, _tmp4_ = string_substring (filename, (glong) 0, string_get_length (filename) - string_get_length (".vapi"))), _g_free0 (_tmp4_), _tmp5_);
		if (g_file_test (dep_file, G_FILE_TEST_EXISTS)) {
			gsize len = 0UL;
			char* buffer;
			char* _tmp8_;
			gboolean _tmp7_;
			char* _tmp6_ = NULL;
			buffer = NULL;
			_tmp7_ = g_file_get_contents (dep_file, &_tmp6_, &len, &_inner_error_);
			buffer = (_tmp8_ = _tmp6_, _g_free0 (buffer), _tmp8_);
			_tmp7_;
			if (_inner_error_ != NULL) {
				if (_inner_error_->domain == G_FILE_ERROR) {
					g_propagate_error (error, _inner_error_);
					_g_free0 (buffer);
					_g_free0 (dep_file);
					_vala_collection_object_unref0 (results);
					_g_free0 (found_vapidir);
					_g_free0 (filename);
					_g_free0 (path);
					return NULL;
				} else {
					_g_free0 (buffer);
					_g_free0 (dep_file);
					_vala_collection_object_unref0 (results);
					_g_free0 (found_vapidir);
					_g_free0 (filename);
					_g_free0 (path);
					g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
					g_clear_error (&_inner_error_);
					return NULL;
				}
			}
			{
				char** _tmp9_;
				char** dep_name_collection;
				int dep_name_collection_length1;
				int dep_name_it;
				dep_name_collection = _tmp9_ = g_strsplit (buffer, "\n", 0);
				dep_name_collection_length1 = _vala_array_length (_tmp9_);
				for (dep_name_it = 0; dep_name_it < _vala_array_length (_tmp9_); dep_name_it = dep_name_it + 1) {
					char* dep_name;
					dep_name = g_strdup (dep_name_collection[dep_name_it]);
					{
						if (string_get_length (dep_name) > 1) {
							ValaList* deps;
							deps = vsc_parser_manager_find_vala_package_filenames (self, dep_name, &_inner_error_);
							if (_inner_error_ != NULL) {
								if (_inner_error_->domain == G_FILE_ERROR) {
									g_propagate_error (error, _inner_error_);
									_g_free0 (dep_name);
									dep_name_collection = (_vala_array_free (dep_name_collection, dep_name_collection_length1, (GDestroyNotify) g_free), NULL);
									_g_free0 (buffer);
									_g_free0 (dep_file);
									_vala_collection_object_unref0 (results);
									_g_free0 (found_vapidir);
									_g_free0 (filename);
									_g_free0 (path);
									return NULL;
								} else {
									_g_free0 (dep_name);
									dep_name_collection = (_vala_array_free (dep_name_collection, dep_name_collection_length1, (GDestroyNotify) g_free), NULL);
									_g_free0 (buffer);
									_g_free0 (dep_file);
									_vala_collection_object_unref0 (results);
									_g_free0 (found_vapidir);
									_g_free0 (filename);
									_g_free0 (path);
									g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
									g_clear_error (&_inner_error_);
									return NULL;
								}
							}
							{
								ValaIterator* _dep_it;
								_dep_it = vala_iterable_iterator ((ValaIterable*) deps);
								while (TRUE) {
									char* dep;
									if (!vala_iterator_next (_dep_it)) {
										break;
									}
									dep = (char*) vala_iterator_get (_dep_it);
									vala_list_insert (results, 0, dep);
									_g_free0 (dep);
								}
								_vala_collection_object_unref0 (_dep_it);
							}
							_vala_collection_object_unref0 (deps);
						}
						_g_free0 (dep_name);
					}
				}
				dep_name_collection = (_vala_array_free (dep_name_collection, dep_name_collection_length1, (GDestroyNotify) g_free), NULL);
			}
			_g_free0 (buffer);
		}
		_g_free0 (dep_file);
	}
	result = results;
	_g_free0 (found_vapidir);
	_g_free0 (filename);
	_g_free0 (path);
	return result;
}


static gboolean vsc_parser_manager_list_contains_string (VscParserManager* self, ValaList* list, const char* value) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (list != NULL, FALSE);
	g_return_val_if_fail (value != NULL, FALSE);
	{
		ValaIterator* _current_it;
		_current_it = vala_iterable_iterator ((ValaIterable*) list);
		while (TRUE) {
			char* current;
			if (!vala_iterator_next (_current_it)) {
				break;
			}
			current = (char*) vala_iterator_get (_current_it);
			if (_vala_strcmp0 (current, value) == 0) {
				result = TRUE;
				_g_free0 (current);
				_vala_collection_object_unref0 (_current_it);
				return result;
			}
			_g_free0 (current);
		}
		_vala_collection_object_unref0 (_current_it);
	}
	result = FALSE;
	return result;
}


VscParserManager* vsc_parser_manager_construct (GType object_type) {
	VscParserManager * self;
	self = g_object_newv (object_type, 0, NULL);
	return self;
}


VscParserManager* vsc_parser_manager_new (void) {
	return vsc_parser_manager_construct (VSC_TYPE_PARSER_MANAGER);
}


ValaCodeContext* vsc_parser_manager_get_pri_context (VscParserManager* self) {
	ValaCodeContext* result;
	ValaCodeContext* res;
	g_return_val_if_fail (self != NULL, NULL);
	vsc_parser_manager_lock_pri_context (self);
	res = _vala_code_context_ref0 (self->priv->_pri_context);
	vsc_parser_manager_unlock_pri_context (self);
	result = res;
	return result;
}


ValaCodeContext* vsc_parser_manager_get_sec_context (VscParserManager* self) {
	ValaCodeContext* result;
	ValaCodeContext* res;
	g_return_val_if_fail (self != NULL, NULL);
	vsc_parser_manager_lock_sec_context (self);
	res = _vala_code_context_ref0 (self->priv->_sec_context);
	vsc_parser_manager_unlock_sec_context (self);
	result = res;
	return result;
}


static GObject * vsc_parser_manager_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	VscParserManager * self;
	GError * _inner_error_;
	parent_class = G_OBJECT_CLASS (vsc_parser_manager_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = VSC_PARSER_MANAGER (obj);
	_inner_error_ = NULL;
	{
		GMutex* _tmp0_;
		GMutex* _tmp1_;
		self->priv->mutex_pri_context = (_tmp0_ = g_mutex_new (), _g_mutex_free0 (self->priv->mutex_pri_context), _tmp0_);
		self->priv->mutex_sec_context = (_tmp1_ = g_mutex_new (), _g_mutex_free0 (self->priv->mutex_sec_context), _tmp1_);
		vsc_parser_manager_add_path_to_vapi_search_dir (self, VALA_VAPIDIR);
		vsc_parser_manager_add_path_to_vapi_search_dir (self, "/usr/local/share/vala/vapi");
		{
			ValaList* pkg;
			pkg = vsc_parser_manager_find_vala_package_filenames (self, "glib-2.0", &_inner_error_);
			if (_inner_error_ != NULL) {
				goto __catch12_g_error;
				goto __finally12;
			}
			if (vala_collection_get_size ((ValaCollection*) pkg) > 0) {
				char* _tmp2_;
				self->priv->glib_file = (_tmp2_ = (char*) vala_list_get (pkg, 0), _g_free0 (self->priv->glib_file), _tmp2_);
			} else {
				_inner_error_ = g_error_new_literal (G_FILE_ERROR, G_FILE_ERROR_EXIST, "no glib-2.0.vapi file found");
				if (_inner_error_ != NULL) {
					_vala_collection_object_unref0 (pkg);
					goto __catch12_g_error;
					goto __finally12;
				}
			}
			_vala_collection_object_unref0 (pkg);
		}
		goto __finally12;
		__catch12_g_error:
		{
			GError * err;
			err = _inner_error_;
			_inner_error_ = NULL;
			{
				g_error ("vscparsermanager.vala:71: Can't find glib vapi file: %s", err->message);
				_g_error_free0 (err);
			}
		}
		__finally12:
		if (_inner_error_ != NULL) {
			g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
			g_clear_error (&_inner_error_);
		}
		{
			ValaList* pkg;
			pkg = vsc_parser_manager_find_vala_package_filenames (self, "gobject-2.0", &_inner_error_);
			if (_inner_error_ != NULL) {
				goto __catch13_g_error;
				goto __finally13;
			}
			if (vala_collection_get_size ((ValaCollection*) pkg) > 0) {
				char* _tmp3_;
				self->priv->gobject_file = (_tmp3_ = (char*) vala_list_get (pkg, 0), _g_free0 (self->priv->gobject_file), _tmp3_);
			} else {
				_inner_error_ = g_error_new_literal (G_FILE_ERROR, G_FILE_ERROR_EXIST, "no gobject-2.0.vapi file found");
				if (_inner_error_ != NULL) {
					_vala_collection_object_unref0 (pkg);
					goto __catch13_g_error;
					goto __finally13;
				}
			}
			_vala_collection_object_unref0 (pkg);
		}
		goto __finally13;
		__catch13_g_error:
		{
			GError * err;
			err = _inner_error_;
			_inner_error_ = NULL;
			{
				g_error ("vscparsermanager.vala:81: Can't find gobject vapi file: %s", err->message);
				_g_error_free0 (err);
			}
		}
		__finally13:
		if (_inner_error_ != NULL) {
			g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
			g_clear_error (&_inner_error_);
		}
	}
	return obj;
}


static void vsc_parser_manager_class_init (VscParserManagerClass * klass) {
	vsc_parser_manager_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (VscParserManagerPrivate));
	G_OBJECT_CLASS (klass)->get_property = vsc_parser_manager_get_property;
	G_OBJECT_CLASS (klass)->constructor = vsc_parser_manager_constructor;
	G_OBJECT_CLASS (klass)->finalize = vsc_parser_manager_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), VSC_PARSER_MANAGER_PRI_CONTEXT, vala_param_spec_code_context ("pri-context", "pri-context", "pri-context", VALA_TYPE_CODE_CONTEXT, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), VSC_PARSER_MANAGER_SEC_CONTEXT, vala_param_spec_code_context ("sec-context", "sec-context", "sec-context", VALA_TYPE_CODE_CONTEXT, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_signal_new ("caches_building", VSC_TYPE_PARSER_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("caches_builded", VSC_TYPE_PARSER_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("sec_cache_builded", VSC_TYPE_PARSER_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void vsc_parser_manager_instance_init (VscParserManager * self) {
	self->priv = VSC_PARSER_MANAGER_GET_PRIVATE (self);
	self->priv->_vapidirs = NULL;
	self->priv->_packages = (ValaList*) vala_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, g_direct_equal);
	self->priv->_built_packages = (ValaList*) vala_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, g_direct_equal);
	self->priv->_sources = (ValaList*) vala_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, g_direct_equal);
	self->priv->_source_buffers = (ValaList*) vala_array_list_new (VSC_TYPE_SOURCE_BUFFER, (GBoxedCopyFunc) g_object_ref, g_object_unref, g_direct_equal);
	self->priv->need_parse_sec_context = 0;
	self->priv->need_parse_pri_context = 0;
	self->priv->parser_pri_thread = NULL;
	self->priv->parser_sec_thread = NULL;
	self->priv->mutex_pri_context = NULL;
	self->priv->mutex_sec_context = NULL;
	self->priv->parsing_suspended = TRUE;
}


static void vsc_parser_manager_finalize (GObject* obj) {
	VscParserManager * self;
	self = VSC_PARSER_MANAGER (obj);
	{
		ValaCodeContext* _tmp4_;
		ValaCodeContext* _tmp5_;
		vsc_parser_manager_suspend_parsing (self);
		if (self->priv->parser_pri_thread != NULL) {
			g_thread_join (self->priv->parser_pri_thread);
			self->priv->parser_pri_thread = NULL;
		}
		if (self->priv->parser_sec_thread != NULL) {
			g_thread_join (self->priv->parser_sec_thread);
			self->priv->parser_sec_thread = NULL;
		}
		vsc_parser_manager_lock_all_contexts (self);
		vala_collection_clear ((ValaCollection*) self->priv->_packages);
		vala_collection_clear ((ValaCollection*) self->priv->_built_packages);
		vala_collection_clear ((ValaCollection*) self->priv->_sources);
		vala_collection_clear ((ValaCollection*) self->priv->_source_buffers);
		self->priv->_pri_context = (_tmp4_ = NULL, _vala_code_context_unref0 (self->priv->_pri_context), _tmp4_);
		self->priv->_sec_context = (_tmp5_ = NULL, _vala_code_context_unref0 (self->priv->_sec_context), _tmp5_);
		vsc_parser_manager_unlock_all_contexts (self);
	}
	_g_free0 (self->priv->glib_file);
	_g_free0 (self->priv->gobject_file);
	__g_list_free_g_free0 (self->priv->_vapidirs);
	_vala_collection_object_unref0 (self->priv->_packages);
	_vala_collection_object_unref0 (self->priv->_built_packages);
	_vala_collection_object_unref0 (self->priv->_sources);
	_vala_collection_object_unref0 (self->priv->_source_buffers);
	_vala_code_context_unref0 (self->priv->_pri_context);
	_vala_code_context_unref0 (self->priv->_sec_context);
	_g_mutex_free0 (self->priv->mutex_pri_context);
	_g_mutex_free0 (self->priv->mutex_sec_context);
	G_OBJECT_CLASS (vsc_parser_manager_parent_class)->finalize (obj);
}


GType vsc_parser_manager_get_type (void) {
	static GType vsc_parser_manager_type_id = 0;
	if (vsc_parser_manager_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (VscParserManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vsc_parser_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VscParserManager), 0, (GInstanceInitFunc) vsc_parser_manager_instance_init, NULL };
		vsc_parser_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "VscParserManager", &g_define_type_info, 0);
	}
	return vsc_parser_manager_type_id;
}


static void vsc_parser_manager_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	VscParserManager * self;
	self = VSC_PARSER_MANAGER (object);
	switch (property_id) {
		case VSC_PARSER_MANAGER_PRI_CONTEXT:
		vala_value_set_code_context (value, vsc_parser_manager_get_pri_context (self));
		break;
		case VSC_PARSER_MANAGER_SEC_CONTEXT:
		vala_value_set_code_context (value, vsc_parser_manager_get_sec_context (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}




